### nono 1.6.4 (2025/12/08)

nono は NetBSD とかで動作する OMRON LUNA-I/LUNA-88K のエミュレータです。 何故か SHARP X68030 と virt-m68k も動いたりするかも知れません。 nono is OMRON LUNA-I/LUNA-88K emulator runs on NetBSD and etc. It can also emulate SHARP X68030 and virt-m68k.

#### Index of this page:

1. ビルド方法 How to build
2. 実行方法 How to execute
3. 設定 Configuration
4. VM について About VM
5. 実行してみる Try it
6. ホストネットワーク設定例 Example of host network setup
7. 既知の問題 Known Issues
8. 過去のバージョンからの移行方法 How to migrate from old versions
9. 変更履歴 Changes
10. 連絡先、ライセンス等 Contact, License, etc

緑背景は新規または目立った更新のあった箇所です。 Green Background is new or updated paragraph.
1. ビルド方法 How to build
ビルドには以下が必要です。 The followings are required for build.

- make (BSD make, not GNU make)
- C/C++ compiler which supports -std=c++14.
  (For gcc, at least 7.4 or later. For clang, at least 7.0 or later.)
- wxWidgets 3.2.x "stable" branch. (3.0.x "old stable" branch would also work.)
- gettext
- libslirp (4.7.0 or later is comfirmed, 4.8.0 is preferred.)

NetBSD(pkgsrc) なら必要なパッケージは x11/wxGTK32 と net/libslirp です。 wxGTK32 の代わりに wxGTK30 でも動くはずです。 If you use NetBSD(pkgsrc), x11/wxGTK32 and net/libslirp are needed. wxGTK30 would also work.

(NetBSD 以外でのビルドはサポートしていませんが) Ubuntu 24.04 ではたぶん以下のパッケージが必要です。 You may need the following packages on Ubuntu 24.04 (though we won't support non-NetBSD platform).

  bmake, build-essential, gettext, libasound2-dev, libbsd-dev, libkqueue-dev, libslirp-dev, libwxgtk3.2-dev, zlib1g-dev

nono のソースアーカイブを展開したら以下のようにビルドします。 `-DRELEASE` がないとハードモードになるので必ず指定してください。 Extract the nono's source archive and build as following. If you don't specify `-DRELEASE`, it will be hard mode.

>     % ./configure [<options>]
>     % make -DRELEASE depend
>     % make -DRELEASE
>     % su
>     # make install

configure には環境変数 CC、CXX でコンパイラを指定することが出来ます。 wx-config が標準的な名前で提供されていないために見付けられない場合には 環境変数 WX_CONFIG にパスを指定することが出来ます。 また configure のオプションとして以下が指定できます。 You can specify C/C++ compiler using environment variable CC and CXX if configure cannot find standard name suitable compiler. You can specify wx-config path using environment variable WX_CONFIG if configure cannot find wx-config. Also, you can specify the following option for `configure`.

- `--disable-avx2` … amd64(x86_64) で AVX2 対応コードを無効にします。 デフォルトでは、コンパイラが AVX2 に対応していることを configure が検出できれば AVX2 対応コードを生成します。 Disable AVX2 support on amd64(x86_64). By the default, it will generate AVX2 supported binary only if configure detects that compiler supports AVX2.
- `--disable-neon` … aarch64 で NEON 対応コードを無効にします。 デフォルトでは、コンパイラが NEON に対応していることを configure が検出できれば NEON 対応コードを生成します。 Disable NEON support on aarch64. By the default, it will generate NEON supported binary only if configure detects that compiler supports NEON.

`make install` により2つの実行ファイルがインストールされます。 `nono` が GUI 版実行ファイル、 `nono-cli` がコマンドライン版です。 `make install` will install two executables. `nono` is the GUI executable and `nono-cli` is the command line executable.

2. 実行方法 How to execute
nono は複数機種に対応しているため設定なしでは起動できません。 設定は設定ファイルかコマンドラインオプションで指定します。 詳細は以下の設定の章を参照してください。 nono supports multiple architectures so that it needs configuration. See the following Configuration section for details.
2.1. コマンドラインオプション Command Line Option

`-c vmpath`
  VM ディレクトリ/設定ファイルを指定します。 vmpath がディレクトリならそのディレクトリの中の nono.cfg を設定ファイルとします。 vmpath がファイルならそれを設定ファイルとします。 そしていずれの場合も 設定ファイルがあるディレクトリを VM ディレクトリとします。 -c オプションを省略すると vmpath をカレントディレクトリとします。 Specifies the VM directory/configuration file. If vmpath is a directory, make nono.cfg in that directory a configuration file. Or if vmpath is a file, make the specified file a configuration file. And in both cases, make the directory where that file is located a VM directory. If `-c` option is omitted, vmpath is considered as the current directory.
`-f`
  高速モードで起動します。 GUI なら起動後にもメニューから変更できますが、その初期値を変えるだけです。 設定の `fast-mode=1` と等価です。 Boot as the fast mode. You can change this mode on GUI menu after boot, and the option only changes its initial state. This option is equivalent to `fast-mode=1` in configuration.
`--fd0 file
--fd1 file`
  (X68030 Only) フロッピーイメージを指定します。 file が相対パスの場合カレントディレクトリからのパスになります。 設定の `fd0-image`、`fd1-image` とは相対パスの起点の違いを除いて同一です。 Specifies the floppy image. If `file` is relative path, it is path from the current directory. This option is equivalent to `fd0-image`, `fd1-image` in configuration except for base directory of the relative path.
`--fontsize height`
  GUI 版のみ。 全サブウインドウの起動時のフォントサイズを指定します。 起動後にメニューから変更できます。 設定の `monitor-fontsize` と等価です。 GUI Only. Specifies the initial fontsize of all sub windows. You can change this value on GUI menu after boot. This option is equivalent to `monitor-fontsize` in configuration.
`--initrd file`
  (virt-m68k Only) カーネルに渡す初期 RAM ディスクのパスを指定します。 file が相対パスの場合カレントディレクトリからのパスになります。 設定の `exec-initrd` とは相対パスの起点の違いを除いて同一です。 Specifies the initial ramdisk image passed to the kernel. If `file` is relative path, it is path from the current directory. This option is equivalent to `exec-initrd` in configuration except for base directory of the relative path.
`-s scale`
  GUI 版のみ。 メインウィンドウの起動時のスケールを実数で指定します。 設定の `mainview-scale` と等価です。 起動後はメニューからプリセットされた倍率と `mainview-scale` で指定された倍率には変更可能です。 GUI Only. Specifies the initial main window scale in real number. This is equivalent to `mainview-scale` in configuration. You can change this scale on GUI menu after boot.
`--show-config`
  設定ファイルと `-V` オプションを読み込んだ結果を表示します。 Shows the result of reading configuration file and parsing `-V` options.
`-v`
  バージョンを表示します。 Shows the version.
`-V name=value`
  設定ファイルで指定した `name=configvalue` の代わりに このオプションの `name=value` を適用します。 `name` が正しくない場合はエラー終了します。 Use this name=value instead of name=configvalue specified in configuration file. If `name` is not correct, it will exit on error.
`-X file`
  ホストの `file` をロードして実行します。 `file` が相対パスの場合カレントディレクトリからのパスになります。 設定の `exec-file` とは相対パスの起点の違いを除いて同一です。 ファイルが gzip 圧縮されていれば自動的に展開します。 (展開後の) ファイル形式は以下の通りですが、 実際にはブートローダとカーネル程度しか想定していません。 また、いずれも起動元デバイスが取得できないなどの問題はあるかも知れません。 Loads and executes host's `file`. If `file` is relative path, it is path from the current directory. This option is equivalent to `exec-file` in configuration except for base directory of the relative path. If the file is gzip'd, it is automatically extracted. The supported file format (after extracting) is the following. Actually, it only assumes bootloaders or kernels. And note that it may not obtain some information that where did I boot from, for example.
  - a.out (OMAGIC) 実行ファイル (おそらくブートローダのみサポート) a.out (OMAGIC) executable (It probably supports bootloaders only)
  - ELF 実行ファイル (おそらくカーネルのみサポート。 NetBSD の実行ファイルのようであれば、 カーネルだと思ってシンボルテーブルも読み込みます) ELF executable (It probably supports the kernel only. If the file is assumed to be NetBSD executable, it will also load symbol tables as the bootloader does to the kernel.)
  - ELF object (Experimental)
  LUNA では設定の `prom-image` (後述) によらず内蔵の互換 ROM で起動します。 `luna-dipsw1` の DIPSW 設定が `dipsw-autoboot=yes` 相当の状態ならそのまま直ちにホストファイルを実行し、 そうでなければ互換 ROM のプロンプトで停止します。 後者の場合でも LUNA-I なら "g" コマンド、LUNA-88K なら "b" コマンドによる ロードはここで指定したホストファイルをロードします。 X68030 では、IPLROM 起動の後の起動デバイスに細工がしてあり、 そこからホストファイルを実行します。 virt-m68k (と NEWS) はこの方法でしか起動できませんので、 実行ファイルの指定は必須になります。 On LUNA, regardless of `prom-image` configuration (see below), it boots the internal emulated PROM. If `luna-dipsw1` configuration meets `dipsw-autoboot=yes`, it will immediately load and execute the host file. Otherwise, it will wait in prompt. Even in this case, "g" command (in LUNA-I) or "b" command (in LUNA-88K) will load the host file that is specified by this option. On X68030, nono hacks the boot device after normal boot from IPLROM, and loads and executes the host file. On virt-m68k (and NEWS), this is the only way to boot.

以下開発用。For developers:

`-b,--b hexaddr[,skipcount]`
  デバッガのブレークポイントを 16進数で指定します。
`--bi inst[:mask][,skipcount]`
  デバッガの命令ブレークポイントを指定します。
`--bv vector[,skipcount]`
  デバッガの例外ブレークポイントを指定します。
`-C`
  ログをコンソールにも出力します。 通常はログウィンドウにだけ出力されます。
`-d`
  起動時にデバッガプロンプトで停止します。
`-D`
  コンソールをデバッガとして使用します。 過去との互換性のために存在していますが、 `-V debugger-driver=stdio` と等価です。
`-H`
  Human68k モードです。→ human.html
`-L name1=level1[,name2=level2,...]`
  ログレベルを指定します。 カンマで区切って複数指定することも出来ます。 `-Lhelp` で name の一覧を表示します。
`-M name[,name2,...]`
  起動時に表示するモニタウィンドウを指定します。 カンマで区切って複数指定することも出来ます。 `-Mhelp` で name の一覧を表示します。

3. 設定 Configuration
nono の設定はいずれも以下の順序で適用されます。 nono's configurations are always applied in the following order.

1. デフォルト値 Default value
2. ~/.nono.cfg があればその内容 Contents of ~/.nono.cfg if exists
3. VM ディレクトリ内の nono.cfg (または -c で指定したファイル) があればその内容 Contents of nono.cfg in the VM directory (or the file specified by -c option) if exists
4. コマンドラインオプション Command line option

ファイルの書式はどちらも `key = value` 形式で1行1項目ずつです。 `key` と `value` の前後の空白は取り除かれます。 また空行と "`#`" で始まる行は無視します。 知らないキーは警告を出した上で無視します。 同じキーが複数回現れた場合、 上に列挙した順に後から書いたほうで上書きし、 同じファイル内でも同様に後に書いたほうで上書きします。 コマンドラインオプション `-V` 等はこれをさらに上書きします。 コマンドラインオプションで同じキーが複数回現れた場合も後に書いたほうが上書きします。 The syntax of both files is `key = value` format, one per line. White spaces before and after `key` and `value` are ignored. Blank lines, lines beginning with "`#`" are also ignored. The lines with unrecognized key are ignored with a warning. If the same key appears more than once, the latter overwrites the former in the above order. If the same key appears in a file, the latter overwrites the former in the same manner. Then, command line option `-V` etc. overwrites them. If the same key appears more than once in the command line option, do in the same manner.

`vmtype` を除くすべての設定項目はそれぞれデフォルト値を持っています。 つまり少なくとも `vmtype` だけは設定ファイルかコマンドラインオプションで指定する必要があります。 All configuration items except `vmtype` have default value. It means, you need to specify at least only `vmtype` by configuration file or commandline option.

設定項目は次の通りです。 The configuration items are:

`vmtype = string`
  VM 種別を以下のいずれかから指定します。 省略不可です。 Specifies the VM type from the following. This field is mandatory.

  | `luna` | … LUNA-I
  | `luna88k` | … LUNA-88K
  | `x68030` | … X68030
  | `news` | … NWS-1750 (Just a joke)
  | `virt-m68k` (or `virt68k`) | … virt-m68k

`cgrom-image = path`
  (X68030 Only) X68030 の外部 CGROM イメージファイルのパスを指定します。 CGROM は 768KB です。 path がファイル名のみなら VM ディレクトリとその親ディレクトリからこのファイル名を検索します。 path が相対パスなら VM ディレクトリからの相対パスになります (現在のディレクトリからではありません)。 空にすると nono 内蔵の互換 CGROM を使用します。 デフォルトは空です。 Specifies the X68030's external CGROM image file path. This CGROM is 768KB. If the path does not have any path delimiters, the VM directory and then its parent directory will be searched. If the path is a relative path, it will be path from the VM directory, not from the current directory. If the path is empty, nono's builtin compatible CGROM will be used. The default value is empty.
`clock-sync = value`
  仮想マシン内の時刻の同期方法を指定します。 `real` なら実時間に同期、`virtual` なら仮想時間に同期します。 Specifies how to synchronize the time in the virtual machine. If `real`, synchronize with the real time; if `virtual`, synchronize with the virtual time.
  - LUNA-I では 60Hz のシステムクロック割り込みと RTC(MK48T02) が対象で、 デフォルトは `real` です。 On LUNA-I, 60Hz system clock interrupt and RTC(MK48T02) are the target. The default is `real`.
  - LUNA-88K では 100Hz のシステムクロック割り込みと RTC(MK48T02) が対象で、 デフォルトは `real` です。 On LUNA-88K, 100Hz system clock interrupt and RTC(MK48T02) are the target. The default is `real`.
  - NWS-1750 ではシステムクロック割り込みと RTC(MK48T02) が対象で、 デフォルトは `real` です。 On NWS-1750, system clock interrupt and RTC(MK48T02) are the target. The default is `real`.
  - virt-m68k では Goldfish Timer の割り込みと Goldfish RTC が対象で、 デフォルトは `real` です。 On virt-m68k, Goldfish Timer interrupt and Goldfish RTC are the target. The default is `real`.
  - X68030 では MFP のタイマー割り込みと RTC(RP5C15) が対象で、 デフォルトは `virtual` です。 MFP の TxDR レジスタの読み出しは、 この指定に関わらず常に `virtual` 相当の動作しか出来ません。 NetBSD/x68k での時間同期 の項も参照してください。 On X68030, MFP timer interrupts and RTC(RP5C15) are the target. The default is `virtual`. Note that reading from MFP TxDR register only works as `virtual`, regardless of this setting. See also Time Synchronization on NetBSD/x68k.
`debugger-driver = string`
  デバッガのコンソールドライバを指定します。 `stdio`、`tcp`、`none` が選択可能です。 `stdio` は標準入出力を使用します。 `tcp` は TCP ポートで TELNET プロトコルで待ち受けます。 `none` ならホスト側とは一切通信を行いません。 デフォルトは `none` です。 Specifies console driver of the debugger. `stdio`, `tcp`, and `none` can be specified. `stdio` uses the standard input/output. `tcp` listens on TCP port using TELNET protocol. `none` doesn't make any communication with the host. The default is `none`.
`debugger-tcp-port = integer`
  デバッガのコンソールドライバが tcp の時の TCP 待ち受けポート番号を指定します。 Specifies the TCP port number that debugger console driver listens.
`dipsw-autoboot = yesno`
  (LUNA and NEWS Only) 機種に依存せず DIPSW を自動起動に設定するかどうか指定します。 "`yes`" なら自動起動するように、 "`no`" なら自動起動しないように DIPSW 設定を上書きします。 "" (空) なら何もしません。デフォルトは "" です。 このオプションは `luna-dipsw1` や `news-dipsw` の状態が設定ファイルやコマンドラインオプションによって確定した後に 該当のスイッチだけを変更します。 Specifies whether to configure DIPSW to boot automatically, regardless of the models. "`yes`" overwrites DIPSW, to boot automatically. "`no`" overwrites DIPSW, not to boot automatically. "" (Empty) does nothing. The default value is "". This option only changes the appropriate switch(es) after the `luna-dipsw1` or `news-dipsw` configuration is determined by the configuration file or command line options.
`dipsw-serial = yesno`
  (LUNA and NEWS Only) 機種に依存せず DIPSW をシリアルコンソールを使うかどうか指定します。 "`yes`" ならシリアルコンソールを使うように、 "`no`" ならシリアルコンソールを使わないように DIPSW 設定を上書きします。 "" (空) なら何もしません。デフォルトは "" です。 `luna-dipsw1` もしくは `news-dipsw` (機種による) の状態が設定ファイルやコマンドラインオプションによって確定した後に このオプションによって該当のスイッチだけを変更します。 NEWS でシリアルコンソールを使わないを選択した場合、 SW1,2,3 は OFF, OFF, ON にセットされ、 NWB-512 モノクロコンソール(未実装) が選択されます。 Specifies whether to configure DIPSW to use serial console, regardless of the models. "`yes`" overwrites DIPSW, to use serial console. "`no`" overwrites DIPSW, not to use serial console. "" (Empty) does nothing. The default value is "". This option only changes the appropriate switch(es) after the `luna-dipsw1` or `news-dipsw` configuration is determined by the configuration file or command line options. If you choose not to use serial console on NEWS, SW1,2,3 will be set OFF, OFF, ON respectively, and NWB-512 monochrome console (not implemented) will be chosen.
`ethernet-macaddr = string
ethernetN-macaddr = string
`
  N 番目のイーサネットデバイスの仮想マシン側の MAC アドレスを指定します。 `XX:XX:XX:XX:XX:XX` 形式で指定します。 `auto` なら自動的に決定します。 デフォルトは `auto` です。 `ethernet-macaddr` は `ethernet0-macaddr` の別名です。
`exec-file = path`
  起動時にロードするホストの実行ファイルを指定します。 -X オプションとほぼ同等ですが、相対パスは VM ディレクトリを起点にします。 Specifiies the host file that will be loaded at startup. This is mostly the same as -X option. The only one difference is that relative path originates the VM directory.
`exec-bootparam = string`
  (virt-m68k Only) カーネルに渡すブートパラメータを指定します。 内容はたぶん OS ごとに異なりますが、 NetBSD/virt68k では "`root=ld0`" (クォートを除く) のようにしてカーネルにルートデバイスを指示します。 Specifies the boot parameter that is passed to the kernel. The syntax may differ depending on the OS, but in NetBSD/virt68k, you can specify the root device to the kernel, like as "`root=ld0`" (excluding quotes).
`exec-initrd = path`
  (virt-m68k Only) カーネルに渡す初期 RAM ディスクイメージのパスを指定します。 --initrd オプションとほぼ同等ですが、相対パスは VM ディレクトリを起点にします。 Specifies the initial ramdisk image passed to the kernel. This is mostly the same as --initrd option. The only one difference is that relative path originates the VM directory.
`extram-size = integer`
  (X68030 Only) 拡張メモリのサイズを MB 単位で指定します。 今の所以下だけが指定できます。 Specifies the extended RAM size in MB. For now, only the following can be specified.
  - `0` … 拡張メモリを使用しません。デフォルトです。 No extended memory. It's default.
  - `16` … TS-6BE16 互換モードで、 アドレス $0100'0000 からの 16MB です。 TS-6BE16 compatible mode. Its address is from $0100'0000 and the size is 16MB.
  - `128/256/512` … 060turbo 互換モードで、 アドレス $1000'0000 からです。 060turbo compatible mode. Its address is from $1000'0000.
`fast-mode = integer`
  起動時の動作モードを指定します。0 なら通常モード、1 なら高速モードです。 デフォルトは 0 です。 コマンドラインオプション `-f` でも高速モードへのみ指定可能です。
`fd-drive = integer`
  (X68030 Only) フロッピードライブの数を 0 から 4 で指定します。 デフォルトは 2 です。 Specifies the number of floppy drives from `0` to `4`. The default is `2`.
`fdN-image = path`
  (X68030 Only) フロッピードライブ N に起動時に挿入するディスクイメージを指定します。 イメージパスが相対パスなら VM ディレクトリからの相対パスになります。 起動後はメニューから操作できます。 デフォルトは空です。 Specifies a diskimage to be inserted to floppy drive N at startup. If the path is relative path, it is from the VM directory. You can also operate them from menu after startup. The default is empty.
`fpu-type = value`
  (X68030 and virt-m68k Only) 68030 に FPU コプロセッサを装着するかどうか指定しています。 この設定は `mpu-type` が `68030` の時のみ有効です。 `none` なら FPU コプロセッサを装着しません。 `68881` なら FPU コプロセッサとして 68881 を装着します。 現状 68882 はサポートしていません。 また `none` の代わりに `0`、 `68881` の代わりに `1` と書くこともできます。 デフォルトは `68881` です。 LUNA-I はたぶん 68881 搭載モデルのみのため変更できません。 Specifies whether to install FPU co-processor or not. This item is meaningful only if `mpu-type` is `68030`. If `none`, FPU co-processor is not installed. If `68881`, 68881 FPU co-processor is installed. 68882 is not supported yet. And, `none` can also be written as `0`, `68881` can also be written as `1`. The default is `68881`. This item cannot be specified on LUNA-I because (probably) all LUNA-I has 68881.
`hostcom-driver = string
hostcom-tcp-port = integer
hostcom-fallback = integer`
  それぞれ `hostcom0-*` の別名です。 These are aliases for `hostcom0-*` respectively.
`hostcomN-driver = string`
  起動時のシリアルポート N のホスト側ドライバを指定します。 `stdio` なら標準入出力を使用します。 `tcp` なら TCP ポートで TELNET プロトコルで待ち受けます。 `console` (または `cons`) ならメイン画面で端末エミュレーションを行います。 `none` ならホスト側とは一切通信を行いません。 Specifies the host driver of serial port N on startup. `stdio` uses the standard input/output. `tcp` listens on TCP port using TELNET protocol. `console` (or `cons`) does a terminal emulation in main panel. `none` doesn't make any communication with the host.

  `hostcomN` と VM 内のデバイス(ポート)との対応は下表の通り VM 種別ごとに固定です。 The correspondence between `hostcomN` and device (port) in the VM is fixed depending on the VM type as the following table.

  hostcom＼VM | LUNA-I/LUNA-88K | X68030 | NWS-1750 | virt-m68k
  --- | --- | --- | --- | ---
  hostcom0 | SIO(uPD7201) Ch.A | SCC(Z8530) Ch.A | SCC(Z8530) Ch.A | Goldfish TTY
  hostcom1 | HD647180 ASCI Ch.0 | N/A | N/A | N/A
  hostcom2 | HD647180 ASCI Ch.1 | N/A | N/A | N/A

  また、VM 種別によって有効なホスト側ドライバの種類とデフォルト値も異なります。 The choices and default value vary depending on the VM type.

  VM | LUNA-I/LUNA-88K | X68030 | NWS-1750 | virt-m68k
  --- | --- | --- | --- | ---
  有効なドライバ Available drivers | stdio tcp none | stdio tcp none | stdio tcp console none | stdio tcp console none
  hostcom0-driver のデフォルト値 Default value | none | none | console | console
  hostcom[12]-driver のデフォルト値 Default value | none | N/A | N/A | N/A

  指定したドライバが使用出来なかった場合エラー終了します。 起動後はメニューからドライバを変更できますが、パラメータは(まだ?)変更できません。 実行中に変更に失敗した場合は none にフォールバックします。 Terminate if the specified driver could not be used. You can change the driver by menu at runtime, but its parameters cannot be changed (yet?). If changing at runtime fails, it will fallback to none.

`hostcomN-tcp-port = integer`
  ホストドライバが tcp の時の TCP 待ち受けポート番号を指定します。 Specifies the TCP port number that host driver listens.
`hostcpu-avx2 = string`
  ホストが amd64(x86_64) の場合にレンダリングに AVX2 アクセラレーションを使うかどうかを指定します。 `auto` なら起動時にホスト CPU が AVX2 をサポートしているか確認し、 サポートしていれば使用します。 `no` なら AVX2 コードを実行しません。 デフォルトは `auto` です。 amd64(x86_64) 以外のホストではこの設定は無視されます。 Specifies whether to use AVX2 acceleration for rendering on amd64(x86_64) host. If `auto`, nono checks whether the host CPU supports AVX2 on startup and use it if it does. If `no`, nono will not execute AVX2 instructions. The default is `auto`. Note that this item is ignored if the host is not amd64(x86_64).
`hostcpu-neon = string`
  ホストが aarch64 の場合にレンダリングに NEON アクセラレーションを使うかどうかを指定します。 `auto` なら使用し、 `no` なら使用しません。 デフォルトは `auto` です。 aarch64 以外のホストではこの設定は無視されます。 Specifies whether to use NEON acceleration for rendering on aarch64 host. If `auto`, nono uses NEON code. If `no`, nono don't use NEON code. The default is `auto`. Note that this item is ignored if the host is not aarch64.
`hostcpu-fastcore = string`
  ホストの CPU がヘテロジニアス構成の場合の高性能コアを列挙します。 コアの番号は `0,1,2` のようにカンマ区切りで指定します。 ハイフンで範囲指定も出来ます。 `-2,3,4-7` は `0-7` と等価です。 どのコアが高性能コアかは dmesg 等で調べてください。 どのスレッドを割り当てるかはユーザは指定できません。 コアが一つも指定されないかすべてのコアが指定された場合はホモジニアス構成とみなします。 `auto` と書くと自動判別ですが現状 Intel CPU のみ対応しています。 対称構成の CPU なら指定不要です。 デフォルトは `auto` です。
`hostkbd-input = string`
  (LUNA and X68030 Only) ホストキーボードの入力モードを指定します。 `char` ならキャラクタ入力モード、 `jp` なら日本語キーボードモードです。 デフォルトは `char` です。 詳細は VM について の章を参照してください。 Specifies the input mode of the host keyboard. `char` means the character mode, `jp` means the Japanese keyboard mode. The defualt is `char`. See About VM for details.
`hostnet-driver = string
hostnet-afpacket-ifname = ifname
hostnet-bpf-ifname = ifname
hostnet-tap-devpath = path
hostnet-usermode-hostfwd = string
hostnet-usermode-net = string
hostnet-usermode-net6 = string
hostnet-fallback = integer
`
  それぞれ `hostnet0-*` の別名です。 These are aliases for `hostnet0-*` respectively.
`hostnetN-driver = string`
  起動時の N 番目のイーサネットデバイスのホスト側ドライバを指定します。 `afpacket`、`bpf`、`tap`、`usermode` のうち configure で検出したものと `auto`、`none` が選択可能です。 Specifies the host driver of N-th ethernet device on startup. `afpacket`, `bpf`, `tap` and `usermode` can be specified only if the configure detects them. `auto` and `none` can always be specified.
  - `afpacket` は Linux の AF_PACKET ソケットを使用します。 ホスト自身とは通信できません。 `afpacket` uses Linux's AF_PACKET socket. It cannot communicate with the host itself.
  - `bpf` は bpf(4) デバイスを使用します。 ホスト自身とは通信できません。 `bpf` uses bpf(4) device. It cannot communicate with the host itself.
  - `tap` は tap(4) デバイスを使用します。 `tap` uses tap(4) device.
  - `usermode` は libslirp を使用したユーザモードです。 nono 自身が NAT ルータ、DHCP サーバ、DNS サーバの機能を持ちます。 `usermode` is an usermode network using libslirp. nono also acts as NAT router, DHCP server and DNS server.
  - `none` ならホスト側とは一切通信を行いません。 `none` doesn't make any communication with the host.
  `auto` は `usermode` と同義ですが、 configure で libslirp が無効になっている場合は `none` と同義になります。 `hostnet0-driver` のデフォルトは `auto`、 `hostnet1-driver` のデフォルトは `none` です。 `auto` is a synonym for `usermode`, but when libslirp is disabled on configure, it is a synonym for `none`. The default of `hostnet0-driver` is `auto`, the default of `hostnet1-driver` is `none`.

  `hostnetN` と VM 内のデバイスとの対応は下表の通り VM 種別ごとに固定です。 The correspondence between `hostnetN` and device in the VM is fixed depending on the VM type as the following table.

  hostnet＼VM | LUNA-I/LUNA-88K | X68030 | NWS-1750 | virt-m68k
  --- | --- | --- | --- | ---
  hostnet0 | Lance(AM7990) | Nereid#0 (RTL8019AS) | Lance(AM7990) | VirtIO Network
  hostnet1 | N/A | Nereid#1 (RTL8019AS) | N/A | N/A

  指定したドライバが使用出来なかった場合エラー終了します。 起動後はメニューからドライバを変更できますが、パラメータは(まだ?)変更できません。 実行中に変更に失敗した場合は none にフォールバックします。 Terminate if the specified driver could not be used. You can change the driver by menu at runtime, but its parameters cannot be changed (yet?). If changing at runtime fails, it will fallback to none.

`hostnetN-afpacket-ifname = ifname`
  ホストドライバが afpacket の時にバインドするインタフェースを1つ指定します。 ifname が `auto` なら使用可能なインタフェースを1つ自動的に選択します。 デフォルトは `auto` です。 なお、このホストドライバではローカルホストとの通信は出来ません。 Specifies an interface name to bind to, when the host driver is afpacket. If `auto` is specified as ifname, it selects an usable interface automatically. The default is `auto`. Note that this host driver cannot communicate with the localhost.
`hostnetN-bpf-ifname = ifname`
  ホストドライバが bpf の時にバインドするインタフェースを1つ指定します。 ifname が `auto` なら使用可能なインタフェースを1つ自動的に選択します。 デフォルトは `auto` です。 なお、このホストドライバではローカルホストとの通信は出来ません。 Specifies an interface name to bind to, when the host driver is bpf. If `auto` is specified as ifname, it selects an usable interface automatically. The default is `auto`. Note that this host driver cannot communicate with the localhost.
`hostnetN-tap-devpath = path`
  ホストドライバが tap の時に使用するデバイスを1つフルパスで指定します。 デフォルトは `auto` で、この場合は自動的にデバイスを選択します。 この時の探し方はホスト OS によって異なります。 Linux なら `/dev/net/tun` を指定したのと同じです。 OpenBSD なら `/dev/tap0` から `/dev/tap9` まで 順番にオープンできるまで試します。 NetBSD (と FreeBSD) ならまず `/dev/tap` でクローニングを試み、 それが失敗すれば `/dev/tap0` から `/dev/tap9` までを 順番にオープンできるまで試します。 いずれの場合も VM ディレクトリかその親ディレクトリに `nono-ifup`, `nono-ifdown` という名前のシェルスクリプトが必要です。 何もすることがない場合でも正常終了する空のシェルスクリプトを用意してください。 Specifies a device pathname, when the host driver is tap. The default is `auto`. The behavior in this case depends on the host OS. On Linux, it's the same as `/dev/net/tun`. On OpenBSD, it will try from `/dev/tap0` to `/dev/tap9` until successful. On NetBSD (and FreeBSD), it will try cloning by `/dev/tap` first. If that fails, then try from `/dev/tap0` to `/dev/tap9` until successful. In all cases, you need to prepare two shell script files which names are `nono-ifup` and `nono-ifdown` in the VM directory or its parent directory. Even if you don't have anything to do in these scripts, you need to prepare empty scripts that will terminate successfully.
`hostnetN-usermode-net = network/netmask`
  ホストドライバが usermode の時の、内部 IPv4 ネットワークのアドレスを指定します。 ネットワークアドレスは `192.0.2.0/255.255.255.0` のようにネットマスクで指定するか `192.0.2.0/24` のようにネットマスク長で指定することも出来ます。 デフォルトは `10.8.0.0/24` です。
`hostnetN-usermode-net6 = network/prefixlen`
  ホストドライバが usermode の時の、内部 IPv6 ネットワークのアドレスを指定します。 ネットワークアドレスは `2001:db8::/64` のようにアドレスとプレフィックス長で指定します。 デフォルトは `fd08::/64` です。
`hostnetN-usermode-hostfwd = entry[;entry[;…]]`
  ホストドライバが usermode の時の、外部から内部へのポートフォワーディングの設定を行います。 1つの entry は
    `protocol,[hostaddr:]hostport,[guestaddr:]guestport`
  のように '`,`'(カンマ) 3つで区切って表します。 protocol は `tcp` か `udp` です。 hostaddr はホストのバインドアドレスで省略すると 0.0.0.0 です。 guestaddr はゲストのアドレスで、 省略すると DHCP でクライアントに配布したアドレスになります (通常は省略します)。 例えば、ホストの 10022/tcp へのコネクションをゲストの 22/tcp に転送したい場合は `tcp,10022,22` となります。 複数指定する場合は '`;`'(セミコロン) で区切って1行に並べます。

  IPv6 には対応していません。

`hostsound-driver = string`
  サウンドデバイスのホスト側ドライバを指定します。 `alsa`、`netbsd`、`sndio` のうち configure で検出したものと `wav`、`none`、`auto` が選択可能です。 Specifies the host sound driver. `alsa`, `netbsd`, and `sndio` are available only if detected by configure. `wav`, `none`, and `auto` are always selectable.
  - `alsa` は Linux の ALSA ライブラリを使用します。 `alsa` uses Linux's ALSA library.
  - `netbsd` は NetBSD の audio(4) デバイスを使用します。 `netbsd` uses NetBSD's audio(4) device.
  - `sndio` は OpenBSD の sndio ライブラリを使用します。 `sndio` uses OpenBSD's sndio library.
  - `wav` は VM ディレクトリに WAV ファイルを出力します。 この WAV ファイルには無音のブロックは出力されません。 `wav` outputs WAV file in the VM directory. This WAV file doesn't contains any silent blocks.
  - `none` はホスト側には一切出力しません。 `none` doesn't output anything.
  - `auto` なら、configure で検出された一つが選択されます。 検出されなければ `none` です。 `auto` selects the one detected by configure. Or act as `none` if no drivers are detected.
  デフォルトは `auto` です。 The default is `auto`.
`hostsound-alsa-device = string`
  ホストドライバが alsa の時のデバイス名を指定します。 デフォルトは `default` です。
`hostsound-netbsd-device = string`
  ホストドライバが netbsd の時のデバイスパスを指定します。 デフォルトは `/dev/sound` です。
`iplrom1-image = path`
  (X68030 Only) X68030 の外部 IPLROM イメージファイルのパスを指定します。 こちらは 0xfe0000..0xffffff の 128KB の部分で、IPLROM30 と呼ばれているほうです。 path がファイル名のみなら VM ディレクトリとその親ディレクトリからこのファイル名を検索します。 path が相対パスなら VM ディレクトリからの相対パスになります (現在のディレクトリからではありません)。 空にすると無償配布されている IPLROM30 を使用します。 デフォルトは空です。 Specifies the X68030's external IPLROM image file path. This one contains 128KB at 0xfe0000..0xffffff and is known as IPLROM30. If the path does not have any path delimiters, the VM directory and then its parent directory will be searched. If the path is a relative path, it will be path from the VM directory, not from the current directory. If the path is empty, the public released IPLROM30 will be used. The default value is empty.
`iplrom2-image = path`
  (X68030 Only) X68030 の外部 IPLROM イメージファイルのパスを指定します。 こちらは 0xfc0000..0xfdffff の 128KB の部分で、ROM30 と呼ばれているほうです。 path がファイル名のみなら VM ディレクトリとその親ディレクトリからこのファイル名を検索します。 path が相対パスなら VM ディレクトリからの相対パスになります (現在のディレクトリからではありません)。 空にすると内蔵 ROM を使用します。 内蔵 ROM は NetBSD/x68k が起動する程度の SCSI IOCS のみサポートしています。 デフォルトは空です。 Specifies the X68030's external IPLROM image file path. This one contains 128KB at 0xfc0000..0xfdffff and is known as ROM30. If the path does not have any path delimiters, the VM directory and then its parent directory will be searched. If the path is a relative path, it will be path from the VM directory, not from the current directory. If the path is empty, internal emulated ROM will be used. The ROM supports only enough SCSI IOCS to boot NetBSD/x68k. The default value is empty.
`keyboard-connect = integer`
  (LUNA and X68030 Only) 起動時にキーボードを本体に接続するかどうかを指定します。 1 なら接続し、0 なら接続しません。デフォルトは 1 です。 起動後はメニューから変更可能です。 Specifies whether to connect keyboard on boot. If 1, it is connected; if 0, it isn't connected. The default is 1. You can change it on GUI menu after boot.
`luna-adjust-misused-epoch = integer`
  (LUNA Only) LUNA で誤った RTC epoch を採用している OS 向けに RTC エミュレーションを補正するかどうかを 指定します。0 なら補正をしません(実機と同じ動作)、 1 なら補正します(現実世界と同じ動作)。 デフォルトは 1 で、通常 1 のままで使用して問題ありません。 Specifies whether nono corrects RTC emulation for OSes that adopts wrong RTC epoch on LUNA. 0 means making no correction (this is the same behavior as the actual machine). 1 means making correction (this is the same behavior as the real world). The default is 1. Normally, leave it 1.

  LUNA で採用している RTC (MK48T02) は2桁で保持している年の値が 4 で割り切れる年をうるう年とする仕様です。 ところが NetBSD/luna68k、OpenBSD/luna88k などはこの RTC の年の値を 1970年からの経過年として使用しています。 例えば1970年はうるう年ではないため 2月28日の翌日は 3月1日ですが、 MK48T02 的には 00年であるためうるう年と認識し 2月28日の翌日が2月29日になります。 このように、これらの OS を使っている場合実機の RTC は4年のうち約2年間、1日ずれた日付を指しているようです。 しかしながら、RTC の時刻は OS 起動時に一度読んだ後は基本的に参照しない上、 今時必要なら NTP で時間を合わせるため、 実機でも問題が顕在化することはまずないと思います。 nono の場合は実機と異なり、アプリケーション実行中しか RTC が進まないため、 補正がない場合の動作が問題になるのは nono を起動したまま偶数年の2月末日から日付をまたいで、 かつ nono を起動したまま OS を再起動して NTP などで時刻修正を行わなかった時 だけだと思います。 このオプションはほぼ開発者向けの動作確認用です。

`luna-dipsw1 = string`
  (LUNA Only) 本体前面 DIPSW#1-1..#1-8 の内容を指定します。 "`0`" を DOWN、"`1`" を UP として、 これを8つ並べた形式で、前から順に #1..#8 に対応します。 Specifies status of the front panel DIPSW#1-1..#1-8 using 8 digits. "`0`" means DOWN and "`1`" means UP. The first character corresponds to #1 and the eighth character corresponds to #8.

  LUNA-I でのデフォルトは `11110111` です。 各スイッチの内容は以下のリンクを参照してください。 On LUNA-I, the default value is `11110111`. See the following link about DIPSW.
  → NetBSD/luna68k: Information
  LUNA-88K でのデフォルトは `11111111` です。 各スイッチの内容は以下のリンクを参照してください。 On LUNA-88K, the default value is `11111111`. See the following link about DIPSW.
  → OpenBSD manual pages: boot_luna88k(8)

  自動起動するかどうかとシリアルコンソールを使うかどうかを指定したい場合は こちらではなく dipsw-autoboot、dipsw-serial 設定を使うほうが便利です。 If you only want to specify whether to autoboot and/or to use serial console, dipsw-autoboot, dipsw-serial configurations are useful.

`luna-dipsw2 = string`
  (LUNA Only) 本体前面 DIPSW#2-1..#2-8 の内容を指定します。 書式は `luna-dipsw1` と同じです。 デフォルトは `11111111` です。 Specifies status of the front panel DIPSW#2-1..#2-8. The same syntax as `luna-dipsw1` is used. The default value is `11111111`.

  NetBSD/luna68k のブートローダは、 DIPSW#2 が "`11111111`" なら自動的にカーネルをロードして実行し、 どれかでも "`0`" にするとプロンプトで停止するようです。 (本当は #8 だけで制御するつもりだったんじゃないかという気がします) NetBSD/luna68k bootloader will automatically load and execute the kernel, if the DIPSW#2 is "`11111111`". Otherwise, the bootloader will enter interactive mode. (I doubt that they actually wanted to switch with only #8)

`luna-video-plane = integer`
  (LUNA Only) LUNA のビデオボードのプレーン数を 1、4、8 から指定します。 1 ならモノクロビデオボード、 4 なら16色 (4bpp) ビデオボード、 8 なら 256色 (8bpp) ビデオボードです。 デフォルトは 4 です。 Specifies number of planes on LUNA video board. The valid values are 1, 4 or 8. 1 means a monochrome video board, 4 means 16-color (4bpp) video board, 8 means 256-color (8bpp) video board. The default value is 4.
`m88100-version = integer
m88200-version = integer`
  (LUNA-88K Only) MPU と CMMU のマスクバージョンを設定します。 今の所これによるエミュレータの動作の違いはありません。 どちらかというとこれを参照しているゲスト OS の動作確認用です。 デフォルトは `m88100-version` が 11、`m88200-version` が 9 です。 Specifies MPU and CMMU mask version. This item doesn't affect any MPU/CMMU emulations for now. But it may be useful for verifying the guest OS behaviors. The default value is 11 for `m88100-version`, 9 for `m88200-version`.
`mainview-scale = double`
  メインウィンドウの起動時のスケールを実数で指定します。 コマンドラインオプション `-s` で上書き可能です。 起動後はメニューから、 プリセットされた倍率とここで指定した倍率には変更可能です。 デフォルトは 1.0 です。
`monitor-fontsize = integer`
  テキスト系モニタとステータスパネルのフォントサイズを 12, 16, 24 から指定します。 コマンドラインオプション `--fontsize` で上書き可能です。 起動後はメニューから変更することができます。 デフォルトは 12 です。
`monitor-rate = integer`
  テキスト系モニタウィンドウの更新頻度を Hz 単位で指定します。 1 から 60 までの間で指定でき、デフォルトは 20Hz です。 起動後にメニューから、 プリセットされた頻度とここで指定した頻度には変更可能です。 Specifies refresh rate of all text monitor windows in Hz. It ranges from 1 to 60. The default is 20Hz. You can choose this value on GUI menu after boot, from preset rate or rate specified here.
`mpu-clock = value`
  MPU のクロック数を MHz 単位で指定します。 デフォルトは LUNA-I なら 20MHz、LUNA-88K と X68030 なら 25MHz です。 virt-m68k ではあまり意味はありませんが 25MHz です。 Specifies the MPU clock in MHz. The default value is 20MHz on LUNA-I, or 25MHz on LUNA-88K and X68030. On virt-m68k, it's less meaningful but 25MHz.
`mpu-type = value`
  (X68030, virt-m68k Only) MPU 種別を `68030` か `68040` で指定します。 デフォルトは `68030` です。 Specifies the MPU type, `68030` or `68040`. The default is `68030`.
`mpu-pseudo-stop = integer`
  (LUNA-88K Only) m88100 にて疑似 STOP 状態を有効にするかどうかを指定します。 0 なら無効(実機と同じ動作)、1 なら有効で、デフォルトは 1 です。 m88100 には、m68k の STOP 命令 (割り込みが上がるまで何もせず待つ) に相当する命令がなく、 大抵ビジーウェイトループで割り込みが上がるのを待つことになります。 これは実機では (消費電力を減らす手段がないという些細な問題以外には) 何のデメリットもないのですが、 エミュレータで特に高速動作させている時には割り込みが上がるまで (例えば人間がキーを入力するまで) ホスト CPU パワーを使い潰してビジーウェイトループを実行し続けることになり、ホスト CPU があっつあつになります。 それを防ぐための機能です。 特徴的な命令列を検出して実現しているので、すべての状況で動作するわけではありません。
`nereid0-enable = integer
nereid1-enable = integer
`
  (X68030 Only) Nereid 拡張ボードを装着するかどうかを指定します。 Nereid は同時に2枚まで使用することができます。 値は `0` なら装着せず、`1` なら装着します。 デフォルトは `0` (装着しない) です。 詳細は 4.6 Nereid の章を参照してください。 Specifies whether install Nereid expansion board or not. Up to two board can be operated at the same time. If `0`, the board is not installed. If `1`, the board is installed. The default value is `0`. See also Section 4.6 Nereid below for details.
`nereid0-net = integer
nereid1-net = integer
`
  (X68030 Only) Nereid ボードの NIC (RTL8019AS) のみを無効にすることが出来ます (実機では通常そのようなことは出来ません)。 `0` なら無効、`1` なら有効です。デフォルトは `1` です。 通常は `1` のまま使用してください。 この設定は対応する `nereidN-enable` が `0` (ボードを装着しない) の場合は意味を持ちません。 This can disable only NIC (RTL8019AS) of Nereid expansion board (although it's not possible normally in the real world). It's disabled if `0`, or enabled if `1`. The default is `1`. Normally, leave it `1`. This item will be ignored if the corresponding `nereidN-enable` is `0`.
`nereid0-ram-size = integer
nereid1-ram-size = integer
`
  (X68030 Only) Nereid ボードのバンクメモリのサイズを MB 単位で指定します。 指定できるのは `0`, `4`, `16` です。 `0` を指定するとバンクメモリを無効にします。 デフォルトは `16` です。 この設定は対応する `nereidN-enable` が `0` (ボードを装着しない) の場合は意味を持ちません。 Specifies bank memory size in MB of Nereid expansion board. The valid values are `0`, `4` or `16`. If `0`, disable the bank memory. The default is `16`. This item will be ignored if the corresponding `nereidN-enable` is `0`.
  また通常は必要ありませんが -4 または -16 を指定すると、 バンクメモリは無効にした上で Nereid 制御ポートのビット6の読み出し値 (バンクメモリの容量) を再現することが出来ます。 -4 ならビット6は 0 (4MB)、0 か -16 なら 1(16MB) が読み出せます。
`news-dipsw = string`
  (NEWS Only) DIPSW の内容を指定します。 "`0`" を OFF、"`1`" を ON として、 これを8つ並べた形式で、前から順に SW1..SW8 に対応します。 デフォルトは `00001000` です。 Specifies status of the DIPSW using 8 digits. "`0`" means OFF and "`1`" is ON. The first character corresponds to SW1 and the eighth character corresponds to SW8. The default valus is `00001000`.
  各スイッチの内容は以下のリンクを参照してください。 See the following link about DIPSW.
  → NetBSD/news68k Frequently Asked Questions

  自動起動するかどうかとシリアルコンソールを使うかどうかを指定したい場合は こちらではなく dipsw-autoboot、dipsw-serial 設定を使うほうが便利です。 If you only want to specify whether to autoboot and/or to use serial console, dipsw-autoboot, dipsw-serial configurations are useful.

`prom-image = path`
  (LUNA Only) LUNA-I/LUNA-88K の外部 ROM イメージファイルのパスを指定します。 path がファイル名のみなら VM ディレクトリとその親ディレクトリからこのファイル名を検索します。 path が相対パスなら VM ディレクトリからの相対パスになります (現在のディレクトリからではありません)。 空にすると内蔵 ROM を使用します。 デフォルトは空です。 Specifies the LUNA-I/LUNA-88K's external ROM image file path. If the path does not have any path delimiters, the VM directory and then its parent directory will be searched. If the path is a relative path, it will be path from the VM directory, not from the current directory. If the path is empty, internal emulated ROM will be used. The default value is empty.

  実機を持っていない場合はこの値を空に (= デフォルトのままに) しておくと、 nono 内蔵のなんちゃって下位互換 ROM で起動します。 If you does not have the real LUNA machines, you can boot with nono's internal downward compatible emulated ROM if you set this field empty (or leave it as the default).

  LUNA-I 実機を持っている場合は ROM ファイルを指定することで実機 ROM で起動できます。 ROM ファイルは実機の 0x41000000-0x4101ffff (128KB) を保存したものです。 今のところ ROM は V4.22 (Thu Jul 27 11:45:42 1989) のみサポートしています。 それ以外については何も分かりません。 If you have the real LUNA-I machine, you can boot with the real ROM spcifying the ROM file path. The ROM file is extracted from 0x41000000-0x4101ffff (128KB) of the real LUNA-I machine. For now, only V4.22 (Thu Jul 27 11:45:42 1989) is supported. I have no idea about other ROMs.

  LUNA-88K 実機の場合は 0x41000000-0x4103ffff (256KB) を保存したものです。 今のところ ROM は version 1.20 のみサポートしています。 For LUNA-88K, the ROM file is extracted from 0x41000000-0x4103ffff (256KB). For now, only version 1.20 is supported.

`ram-size = integer`
  搭載する RAM サイズを MB 単位で指定します。Specifies the RAM size in MB.
  - LUNA-I のデフォルトは 16MB です。 16MB 未満は 4MB 単位で、 16MB 以上は 512MB まで 1MB 単位で指定できます。 ただし `prom-image` で実機イメージを指定した場合は 255MB が上限になります。 ちなみに NetBSD/luna68k の起動には最低でも 8MB 必要です。 On LUNA-I, the default is 16MB. If the size is less than 16MB, you can specify in 4MB unit. If larger, you can specify up to 512MB in 1MB unit. However, if you have `prom-image` with the real image, the maximum is limited to 255MB. By the way, NetBSD/luna68k needs at least 8MB to boot.
  - LUNA-88K のデフォルトは 64MB です。 64MB 未満は 16MB 単位で、 64MB 以上は暫定で 512MB まで 1MB 単位で指定できます。 ただし `prom-image` で実機イメージを指定した場合は 240MB が上限になります。 On LUNA-88K, the default is 64MB. If the size is less than 64MB, you can specify in 16MB unit. If larger, you can specify up to tentative 512MB in 1MB unit. However, if you have `prom-image` with the real image, the maximum is limited to 240MB.
  - X68030 ではメイン RAM 容量を示し、デフォルトは 12MB です。 4MB から 12MB まで 1MB 単位で指定できます。 拡張メモリについては extram-size を参照してください。 On X68030, the default is 12MB. You can specify it in 1MB unit from 4MB to 12MB. See extram-size for extended memory.
  - NWS-1750 では現状 16MB で変更できません。 On NWS-1750, This is 16MB fixed for now.
  - virt-m68k のデフォルトは 128MB です。 16MB から 4080MB まで指定可能です。 指定された値が 16MB で割り切れない場合は 16MB 単位に切り上げになります。 On virt-m68k, the default is 128MB and the range is 16MB to 4080MB. If the specified size is not divisible by 16MB, it will be rounded up to 16MB.
`rtc-epoch-year = integer`
  (LUNA Only) RTC (MK48T02) の基準年を指定します。 デフォルトは 1970年です。 NetBSD/luna68k、OpenBSD/luna88k はいずれも基準年を 1970年としていますので、 デフォルトのままで構いません。 ゲスト OS に 4.4BSD を使用する際は 1900 を指定します。 NEWS では今の所 1900 固定で変更出来ません。 Specifies the RTC (MK48T02) epoch year. The default is 1970. Since both NetBSD/luna68k and OpenBSD/luna88k use 1970 as epoch year, there is no need to touch this value. If you boot 4.4BSD on LUNA-I as the guest OS, specify 1900. On NEWS, it is fixed at 1900.
`show-statuspanel = integer`
  ステータスパネルを表示するかどうかを指定します。 0 なら非表示、1 なら表示です。 デフォルトは 1(表示) です。 起動後はメニューから変更可能です。 Specifies whether to display the status panel or not. If 0, it is hidden; if 1, it is shown. The default is 1 (show). You can change it on GUI menu after boot.
`spc0-idN-image = devtype[,path]`
  (LUNA and X68030 Only) SCSI デバイスとイメージを指定します。キーの N には 0 から 7 が入ります。 ただし ID 7 は本体が使用しますので指定しないでください。 値はデバイス種別 devtype とディスクイメージパス path を "`,`"(カンマ) で区切って並べた形式です。 デバイス種別 devtype は以下のいずれかです。 Specifies SCSI device and image. N in the key is 0 to 7. But don't specify ID 7 because the host uses it. The value is in a form of device type devtype and the disk image path path separated by "`,`"(comma). devtype can be one of the following:
  - `hd` … HD drive
  - `cd` … CD-ROM drive
  - `mo` … MO drive

  devtype が `hd` なら path は省略できません。 devtype が `cd` か `mo` なら path は省略可能です。 イメージパスが相対パスなら VM ディレクトリからの相対パスになります。 If devtype is `hd`, path cannot be ommitted. If devtype is `cd` or `mo`, path can be ommitted. If the path is relative path, it is from the VM directory.

  例えば、nono.cfg と同じディレクトリに置いた sd0.img を 起動 HDD ディスクイメージとして使い (LUNA では通常 ID 6 をプライマリ HDD に割り当てます)、 ID 5 に同じディレクトリの install.iso をセットした CD ドライブを、 ID 4 に起動時メディアなしの MO ドライブを接続する場合は次のようになります。 For example, if you use a harddisk image sd0.img placed in the same directory as nono.cfg (LUNA usually assigns ID 6 to the primary HDD), ID 5 for CD-ROM drive that loads install.iso in the same directory, and ID 4 for MO drive without media on boot, write as following:

  >     spc0-id6-image = hd,sd0.img
  >     spc0-id5-image = cd,install.iso
  >     spc0-id4-image = mo

`spc0-idN-seektime = integer`
  (LUNA and X68030 Only) 指定の SCSI HDD の平均シークタイムを msec 単位で指定します。 現在のデフォルトは `0` です (S・S・D!! S・S・D!!)。 16 程度を指定すると幾分往時に思いを馳せることが出来るかもしれませんが、 今の所あまり安定していません。 Specifies the average seek time of specified SCSI HDD in msec. Currently, the default value is `0` (This may be something like SSD :-). If you specify about 16 or so, you can feel nostalgic, but this feature is still unstable.
`spc0-idN-writeignore = integer`
  (LUNA and X68030 Only) 指定の SCSI HD デバイスへの書き込みをイメージに書き戻すかどうか指定します。 `0` なら通常動作(書き込みを行う)です。 `1` ならディスクイメージに一切書き戻しません。 デバイスへ書き込んだはずのデータは Copy-On-Write の要領で、 VM ディレクトリ内の一時ファイルに書き込みます。 この一時ファイルはアプリケーション終了時に削除します。 fsck を気にせずカーネルのデバッグとかを行いたい場合にはどうぞ。 何が起きるか意味が分からない人は指定しないでください。 デフォルトは `0` です。 Specifies whether nono writes a writing to SCSI HD devices back to the diskimage. `0` means normal operation (writes to the diskimage). `1` means that nono will not write to the diskimage back. Data that the guest wrote to the device will be written to a temporary file in the VM directory, like Copy-On-Write. The temporary file will be removed when the application exits. This is useful for kernel debugging because it does not require fsck after the kernel hangs or reboots. Don't use this flag if you don't understand this paragraph. The default value is `0`.

  ちなみに、メディアを書き込み禁止にしたい場合はこれではなく、 イメージファイルの書き込み権を落としてください。 By the way, if you want to make the media write-protected, clear the write permission from the image file (instead of this setting).

`sram-sync-ramsize = integer`
  (X68030 Only) SRAM の RAM 容量欄を実際の RAM サイズに合わせるかどうかを指定します。 `0` なら何もしません (実機と同じ)。 `1` なら、アプリケーション起動時に SRAM の $ed0008.L (RAM 容量) を ram-size の設定値で更新します。 この更新は、 アプリケーション起動時に SRAM マジックが正しく書かれている場合のみ行われます。 デフォルトは `1` です。 Specifies whether to synchronize a RAM size field in SRAM with real RAM size or not. If `0`, the application will do nothing (as same as the real). If `1`, the application updates(synchronizes) $ed0008.L (RAM size) in SRAM with configuration value of ram-size. This update is performed once only if the SRAM magic string is correct at the application startup. The default is `1`.
`virtio-blockN-image = path`
  (virt-m68k Only) VirtIO ブロックデバイスのイメージを指定します。 キーの N は現状 0 から 7 が指定可能です。 イメージパスが相対パスなら VM ディレクトリからの相対パスになります。 Specifies VirtIO block device's image. N in the key is 0 through 7 for now. If the path is relative path, it is from the VM directory.
`virtio-blockN-writeignore = integer`
  (virt-m68k Only) 指定の VirtIO ブロックデバイスへの書き込みをイメージに書き戻すかどうか指定します。 詳細は `spc0-idN-writeignore` を参照してください。 Specifies whether nono writes a writing to VirtIO block devices back to the diskimage. See `spc0-idN-writeignore` for details.
`virtio-scsi-idN-image = devtype[,path]`
  (virt-m68k Only) VirtIO SCSI デバイスとイメージを指定します。 イニシエータ ID が不要なため、 キーの N には 0 から 7 が指定できます。 詳細は `spc0-idN-image` を参照してください。 Specifies VirtIO SCSI device and image. You can specify all of 0 thorugh 7 for the key N, because there is no initiator. See `spc0-idN-image` for more details.
`virtio-scsi-idN-writeignore = integer`
  (virt-m68k Only) 指定の VirtIO SCSI デバイスへの書き込みをイメージに書き戻すかどうか指定します。 詳細は `spc0-idN-writeignore` を参照してください。 Specifies whether nono writes a writing to VirtIO SCSI devices back to the diskimage. See `spc0-idN-writeignore` for details.
`windrv-path = path`
  (X68030 Only) Windrv でゲスト側に見せるホストディレクトリを指定します。 今の所指定できるディレクトリは1つだけです。 空なら Windrv デバイスが存在しないように振る舞います。 デフォルトは空です。
`x68k-cut-fc2 = integer`
  (X68030 Only) MPU (68030) の FC2 ピンを切断するかどうかを指定します。 `0` なら切断しません (標準の状態)。 `1` なら切断します。 デフォルトは `1` です。 NetBSD/x68k で X サーバを起動する場合のみ `1` にする必要があります。 Specifies whether to cut MPU(68030) FC2 pin. If `0`, the FC2 pin is connected as usual. If `1`, it is disconnected. The default is `1`. Only if you run the X server on NetBSD/x68k, it needs to be `1`.
`xp-clock = value`
  (LUNA Only) XP プロセッサのクロック数を MHz 単位で指定します。 デフォルトは 6.144 [MHz] です。

4. VM について About VM
4.1. 実装状況 Implementation Status

◎ | : ほぼ実装済み Mostly implemented
○ | : 困らない程度には実装済み Works
△ | : とりあえず動いてる程度 Works somehow
× | : 未実装 Not implemented
— | : 実装予定なし Not planned

LUNA-I
MPU (68030) | ◎ |
FPU (68881) | ◎ |
BT454 | ◎ |
CRTC2 | ○ | 標準で使用する値のみサポート
Frame buffer | ◎ |
Keyboard/Mouse | ◎ |
SIO (uPD7201) | ◎ |
PIO (8255) | ○ |
Ethernet (AM7990) | ◎ |
NVRAM&RTC (MK48T02) | ◎ |
Front LCD | ◎ |
SPC (MB89352) | ◎ |
SCSI HD/CD/MO Devices | ○ |
XP(HD647180) CPU | △ |
XP(HD647180) Timer0/1 | ○ |
XP(HD647180) ASCI | ○ |
XP(HD647180) その他の内蔵デバイス Other internal devices | × |
XP 周辺デバイス Peripheral devices | × |
電源 Power Circuit | ○ |
LUNA-88K specific
MPU (88100 part) | ○ | マルチプロセッサ未実装、バグも未実装? MP (and bugs?) not implemented
MPU (88200 part) | ◎ |
MPU (88110) | — | 実装予定なし Not planned
FUSEROM | ○ |
X68030
MPU (68030) | ◎ | 68EC030 は実装予定なし 68EC030 is not planned
FPU (68881) | ◎ | 68882 は未実装 68882 not implemented
MPU (68040) | △ | キャッシュ未実装、実行サイクル未考察
DMAC | △ |
CRTC/VC | △ | 768x512 画面モードのみサポート Only 768x512 screen mode is supported
FDC/FDD | ○ |
標準・拡張エリアセット Areaset | ◎ |
ADPCM | ○ | フィルタ未実装、録音は実装予定なし Filter is not implemented. Recording is not planned
OPM | × |
テキスト画面Text screen | ○ |
コントラスト Contrast | ◎ |
グラフィック機能全般 All other graphics | △ | グラフィック画面(1024x1024 モード)、画面間プライオリティ(合成を除く)、個別画面オンオフのみ実装。これ以外は当面予定なし。
Keyboard | ◎ | TVコントロールを除く Except TV Control
Mouse | ◎ | 本体接続のみ
MFP | △ |
PPI (8255) | △ |
Printer | × |
RTC | ◎ | アラームを除く Except Alarm
SPC (MB89352) | ◎ |
SCSI HD/CD/MO Devices | ○ |
SCC (Z8530) | ◎ |
SRAM | ◎ |
システムポートSystem port | △ |
電源 Power curcuit | ○ |
Nereid Ethernet | ◎ |
Nereid Bank memory | ◎ |
Nereid USB | — | 実装予定なし Not planned
拡張メモリ Extended memory | ○ |
Windrv | △ |
NWS-1750
MPU (68030) | ◎ |
FPU (68881) | ◎ | 68882 は未実装 68882 not implemented
PROM | × |
SCC (Z8530) | ◎ | チャンネル A のみホストに接続 Only channel A is connected to the host
Ethernet (AM7990) | ◎ |
NVRAM&RTC (MK48T02) | ◎ |
Video Board | × |
Keyboard/Mouse | × |
SCSI Controller | × |
IDROM, DIP-SW, 100Hz Timer, 診断用LED | ○ |
AST, Lv2Intr | × |
電源 Power Circuit | × |
virt-m68k
MPU (68030) | ◎ |
FPU (68881) | ◎ | 68882 は未実装 68882 not implemented
MPU (68040) | △ | キャッシュ未実装、実行サイクル未考察
Goldfish PIC | ◎ |
Goldfish RTC | ◎ |
Goldfish Timer | ◎ |
Goldfish TTY | ○ |
VirtIO Block | ○ |
VirtIO Network | ○ |
VirtIO Entropy | ◎ |
VirtIO SCSI | ○ |
Power Control | ○ |

4.2. MPU (68030)
MMU、キャッシュあたりはほぼ実装していると思います。 命令の実行サイクルについてはある程度似せているつもりですが、 68000 のようにサイクル数を正確に数えるのは困難です。
4.3. MPU (68040)
いくつか未実装の命令があります。 キャッシュは未実装で、 それに伴いキャッシュ制御を行う新設命令 CINV*, CPUSH* も未実装です。 MMU、ATC はまだ怪しいです。 FPU はある程度動作すると思いますが 例外を起こす細かい条件は未検証のため、 本来は例外が起きてソフトウェア (FPSP) で処理するはずのものが 68881 相当のハードウェアエミュレーションで実行出来てしまうという 通常あまり困らないタイプの問題は存分にあります。
命令の実行サイクルについてはある程度似せているつもりですが、 そもそも 68040 はパイプライン方式なので 68000 時代のようにサイクル数を 正確にエミュレーションすることはおそらく不可能です。
68040 は X68030 と virt-m68k でのみ選択可能です。 NEWS に 68040 搭載モデルはなさそうなのと、 LUNA では 68040 搭載モデルは LUNA-I ではなく LUNA-II になるからです。
4.4. LUNA の ROM エミュレーション
LUNA-I、LUNA-88K で PROM の外部イメージを指定しない場合 (`prom-image` が空の場合)、 内蔵の独自 ROM が動作し、コンソールモニタが起動します。 このコンソールモニタの動作は実機のそれとよく似ていますが、 これは実機確認の際に操作方法が違いすぎると(自分が)困るため仕方なく似せているもので、 忠実なコピーを作る目的ではありません。
4.5. X68030 の ROM (ROM30) エミュレーション
X68030 で ROM30 の外部イメージを指定しない場合 (`iplrom2-image` が空の場合)、内蔵の独自 ROM が組み込まれます。 本来の ROM30 には SCSIIOCS の他に ROM デバッガなどが含まれていますが、 内蔵 ROM はこのうち SCSIIOCS を NetBSD/x68k が起動するのに十分なだけしか 実装していません。 Human68k を起動する場合はお手元の実機から ROM イメージを作成してください。
4.6. X68030 のグラフィック画面
X68030 のグラフィック画面を一部実装しています。 これにより NetBSD/x68k の標準設定の X サーバは起動します。 グラフィック画面として実装しているのは 1024x1024 (16色) モードのみです。 ビデオコントローラは、画面間プライオリティと画面オンオフを実装しており、 テキスト画面とグラフィック画面の優先度を変更することは出来ます。 ただし合成や半透明合成は未実装ですので実質切り替えられるだけです。 スクロール等 CRTC の機能も未実装です。
4.7. NEWS エミュレーション
NEWS エミュレーションは今の所 `-X` オプションでカーネルを直接起動することしか出来ません。 PROM も NetBSD/news68k の起動と終了に最低限必要な程度が誤魔化してあるだけです。 また、デバイスの配置や、デバイスが存在しないアドレスへのアクセスが どうなるかなどは実機確認をしていないため分かりません。 従って、動くものは動く、程度のものでしかありません。 というかネタです。
4.8. virt-m68k エミュレーション
QEMU の "virt" (架空ハードウェア仕様)の互換機ｗをサポートしています。 NetBSD/virt68k が動作します。 `-X` オプション (または設定の `exec-file`) でカーネルを、 設定の `exec-bootparam` でルートデバイスを それぞれ指定してください。 インストール時には `--initrd` (または設定の `exec-initrd`) で RAM ディスクイメージも指定します。 Supports QEMU "virt" virtual hardware's compatible machine and it can run NetBSD/virt68k. You need to specify the kernel by `-X` option (or `exec-file` in configuration). If you want to install, you also need to specify the ramdisk image by `--initrd` option (or `exec-initrd` in configuration).
4.9. シリアルコンソールの端末エミュレーション
virt-m68k (や NEWS) のようにシリアルコンソールしか持たない機種のために、 メイン画面でシリアルコンソールの端末エミュレーションを実装してあります。 `hostcom-driver = cons` とすることで nono のメイン画面に シリアルコンソールの内容が表示されます。 カラーは現状サポートしていませんが、 ボールド、イタリック、下線などはある程度サポートしています。 バックログはありませんので、バックログが必要なら `stdio` 等を使ってください。
4.10. usermode ネットワーク
usermode ネットワークでは nono 自身が NAT ルータ、DHCP サーバ、DNS サーバの機能を持ちます。 ルータと DHCP サーバのアドレスはネットワークアドレス +1 (デフォルトでは 10.8.0.1)、 DNS サーバのアドレスはネットワークアドレス +2 (デフォルトでは 10.8.0.2) です。 IPv6 ルータのアドレスはネットワークアドレス +1 (デフォルトでは fd08::1)、 DNS サーバのアドレスはネットワークアドレス +2 (デフォルトでは fd08::2) です。
4.11. X68030 の Nereid エミュレーション
現実の Nereid はイーサネット/メモリ/USB の複合拡張ボードで、 このうちメモリは、メインメモリの増設に使える他、 メインメモリとして使わなかった領域をバンクメモリとして使うことも出来ます。 nono ではこの Nereid の機能のうちイーサネット (RTL8019AS) とバンクメモリのみサポートします。 メインメモリの増設機能はエミュレータでは意味がないので実装しません。また USB (SL811HS/T) の実装予定はありません。 Nereid in the real world is a combined Ethernet/memory/USB expansion board. Of these, the memory can be used to expand main memory, and areas not used for the main memory can be used as bank memory. nono supports only ethernet (RTL8019AS) and bank memory among the functions of the Nereid expansion board. Main memory expansion is not supported because it's meaningless on emulators. Also, USB (SL811HS/T) is not planned for implementation.
Nereid は DIPSW6,7 によりアドレス・割り込みベクタの組を2通り指定できるため、 2枚まで同時に運用することが出来ます。 本来 SW6 と SW7 は (衝突さえしなければ) 任意に組み合わせることが可能ですが、 nono では簡便のためボード #0 は SW6,7 が OFF、 ボード #1 は SW6,7 が ON と固定しています。 Since Nereid can set to two different combinations of addresses and interrupt vectors by DIPSW, so up to two boards can be operated at the same time. Originally, SW6 and SW7 can be arbitrarily combined (as long as they don't collide), in nono however, for simpility, SW6 and SW7 are fixed to be OFF on board #0, and SW6 and SW7 are fixed to be ON on board #1.

> | #0 (`nereid0-*`) | #1 (`nereid1-*`)
> --- | --- | ---
> ベースアドレス・割り込みベクタ Base address and interrupt vectors | $ece300,$f9,$fb (SW7=OFF) | $eceb00,$f8,$fa (SW7=ON)
> バンクメモリウィンドウ Bank memory window | $ee0000 (SW6=OFF) | $ef0000 (SW6=ON)

バンクメモリは、メインメモリとして使わなかった領域を使用します。 そのため実機でもバンクメモリの容量は DIPSW のメインメモリ割り当て設定 (SW1-5) に依存します。 nono に関係する結論だけでいうと、 メインメモリへの割り当てを一切行わない場合はバンクメモリは 16MB 確保でき、 メインメモリへの割り当てをいくらかでも行うとバンクメモリは 4MB となります。 設定の `nereidN-ram-size` はこの部分を指定していることになります。 またこの容量とは独立に SW8 でバンクメモリの有効・無効を指定できますので、 `nereidN-ram-size` が 0 (以下) というのは SW8 でバンクメモリを無効にしたことに相当します。 Bank memory uses memory areas not used as the main memory. So the bank memory size depends on the main memory settings (SW1-5). As a result, only if you don't allocate any memories to main memory, the bank memory can be allocated 16MB. Otherwise, the bank memory will be allocated 4MB. Thus, `nereidN-ram-size` specifies this value. Also, SW8 specifies enable/disable of the bank memory regardless of the size, `nereidN-ram-size = 0` (or less) means disabling the bank memory.
4.12. NetBSD/x68k での時間同期Time Synchronization on NetBSD/x68k
X68030 でゲスト OS に NetBSD/x68k を使う場合、 nono と NetBSD/x68k を次の通りに設定すれば nono をフルスピード動作にしてもゲスト OS の時間がずれなくなります。 まず nono の設定ファイルに以下を追加します。

>     clock-sync = real

ゲストの NetBSD/x68k を起動し、 `/etc/sysctl.conf` に以下の1行を追加します。

>     kern.timecounter.hardware=clockinterrupt

さらに `/etc/rc.conf` に

>     ntpdate=YES
>     ntpdate_hosts=ntp.nict.jp

などと設定します (NTP サーバはお好みで)。 sysctl の設定によって、ゲスト OS の時計は「この設定が有効になった時点から」 実時間間隔を刻めますが、 電源オンからここまでにずれた分が解決できるわけではありませんので、 必然的に時計を合わせる必要もあるためです。 これで再起動すると次回からはフルスピードでも実時間を刻めます。 (再起動せずに有効にしたい場合はこの設定の後 root ユーザで

>     /etc/rc.d/sysctl start
>     /etc/rc.d/ntpdate start

を実行してください)
4.13. Windrv
X68030 で Windrv を一応サポートしています。 Human68k からホストのファイルシステムをアクセスする機構です。 従来の Windrv とはホスト OS の前提が異なるため、 既存実装からの移植ではありませんし、 そもそも Human68k とホスト(UNIX)ファイルシステムの差異による制約も多くあります。 これらを把握してから使用してください。

- ファイル名は21文字すべて認識します。 22文字以上(というか 18.3 形式以外)のファイル名はゲストからは見えません。
- ファイル名中の ASCII 以外の文字には現状対応していません。 これらの文字を含むファイルはゲストからは見えません。
- マルチピリオドには対応していません。 このようなファイルはゲストからは見えません。
- 大文字小文字は区別しません。 大文字小文字だけが違う同名のファイル (例えば a.BAK と a.bak) があると、 検索(FILES/NFILES) には現れません。 この状況で a.Bak (大文字小文字を区別していれば違うファイル) を新規作成しようとすると (大文字小文字を区別しないゲスト OS からは a.Bak というエントリは存在しないように見えるにも関わらず) 作成できなくしてあります。
- ファイルサイズが 2GB 以上のファイルはゲストからは見えません。
- Human68k 側の属性は A(アーカイブ)/D(ディレクトリ)/R(読み込み専用) のみ対応しています。 S(システム)/H(隠しファイル)属性は保存されません。
- ホストのシンボリックリンクは、リンク先の ファイルもしくはディレクトリとして見えます。 またリンク先が Windrv のルートパスの外側を指していても構いません。
- ファイルのロックには対応していません。
- WindrvXM.sys による拡張動作には対応していません。 windrv 互換として動作します。
- TwentyOne.x は現状 +T/-C/-P/-S (いずれもデフォルト) 相当だと思います。 TwentyOne.x が常駐していないとか、 これ以外のオプションの時にどうなるかは把握していません。
- lndrv.x によるゲスト側のシンボリックリンク機能には未対応です。

Windrv を使用する場合、まず nono の設定ファイルに `windrv-path` を設定します。 次にゲストの Human68k の CONFIG.SYS に WINDRV.SYS (または WindrvXM.sys) を設定してください。

>     DEVICE = \SYS\WINDRV.SYS

4.14. ステータスパネル Status Panel
ステータスパネル中央にあるパフォーマンスメータのアイコンは 高速モードの状態を表示しています。 ダブルクリックすると高速/等速モードの指定を切り替えることができます。 The performance meter's icon at the center of the status panel shows the VM speed status. You can switch full speed / syncronized mode by double-clicking on this icon.

| … | マークなしの場合、ユーザが等速モードを指定していて、等速モードで実行中です。 When no icons are displayed, the user has specified syncronized mode and the VM is running in synchronized mode.
| … | 三角3つの場合、ユーザが高速モードを指定していて、高速モードで実行中です。 高速モード中はパーセントではなく何倍速で動作しているかを表します。 When an icon (three triangles) is displayed, the user has specified full speed mode and the VM is running in full speed mode.
| … | 三角2つの場合、ユーザが高速モードを指定していて、等速モードで実行中です。 以下のいずれかの状態で起きます。 When an icon (two triangles) is displayed, the user has specified full speed mode and the VM is running in synchronized mode. This will happen when any of the following occurs: キー押下中(後述)あるいはキーボードブザー発声中 When any keys are pressed (see below), or the keyboard buzzer is sounding. STOP instruction on m68k. pseudo STOP state on m88k.

4.15. DIPSW 設定ウィンドウ
DIPSW 設定ウィンドウでの変更はアプリケーション起動中のみ有効です。 またここでの設定は即 VM に反映されますが、 LUNA の場合 DIPSW の状態を PIO(8255) がラッチするのが概ね起動時および再起動時のみとなっています (厳密には PROM と XP が云々ですが)。
4.16. メモリダンプモニタ Memory Dump Monitor
メモリダンプモニタの出力形式を、バイト、ワード、ロングワード (m88k ではそれぞれバイト、ハーフワード、ワードと表現します) から選択できます。 また 68030/88200 の MMU ディスクリプタとして表示させることもできます (この位置が正しいディスクリプタかどうかは関係なく表示します)。 逆アセンブルは、 LUNA-I なら m68k と HD64180 の逆アセンブルが、 LUNA-88K なら m88k と HD64180 の逆アセンブルが、 X68030/virt-m68k/NEWS なら m68k の逆アセンブルが選択できます。 On memory dump monitor, you can select the output format from byte, word and longword (In m88k, it is represented as byte, halfword and word respectively). Also you can select 68030/88200 MMU descriptor format (It displays regardless of whether this address is used as descriptor or not). Disassemble is now merged from disassemble monitor. On LUNA-I, you can select m68k and HD64180 disassemble. On LUNA-88K, you can select m88k and HD64180 disassemble. On X68030/virt-m68k/NEWS, you can select m68k disassemble.

表示されているダンプ値をダブルクリックすることでメモリの値を編集できます。 編集できるのはメモリと以下の部分のみです。 You can edit the memory value by double click. Only memory and the following areas are editable.

- NVRAM (LUNA and NEWS Only) … 編集するとただちにファイルも更新します。 後ろの8バイトのみ時計レジスタを兼ねているため編集不可です。 The backend file is also updated immediately when edited. The only last 8 bytes are not editable since there are the clock registers.
- Bitmap framebuffer (LUNA Only) … 共通プレーンは書き込み不可です。 The common plane is not editable.
- SRAM (X68030 Only) … 編集するとただちにファイルも更新します。 The backend file is also updated immediately when edited.
- TVRAM、GVRAM とパレット (X68030 Only) Text VRAM, Graphic VRAM and palette

4.17. ページテーブルモニタ Page Table Monitor
68030 と 68040 のページテーブルを一覧できるモニタです。 88200 は未対応です。 68030 はバリエーションが多すぎるのですべてには対応していません。 This is a page table monitor on 68030 and 68040. It doesn't support 88200 yet. It doesn't support all variations of 68030 because it's too complex.

- 現状、段数は TIC までの3段階まで、FCL には未対応です。 Up to 3-levels (From TIA to TIC). No FCL supported.
- アーリーターミネーションと間接ディスクリプタは表示で区別していませんので 自身で判断してください。 An early termination and indirect descriptor are not distinguished in the display.
- ルートポインタの切り替えは、68040 ではそのまま SRP/URP レジスタの切り替えです。 68030 では TC によって SRP/CRP の使い方が変わるため、 SRP/CRP の切り替えではなく スーパーバイザ状態/ユーザ状態でのルートポインタを選択します。 The root pointer switching on 68040 is SRP/URP as is. On 68030, it switches supervisor-state/user-state.

4.18. デバイスマップモニタ Device Map Monitor
m68k/m88k バスに接続されているデバイスを表示します。 32ビットアドレスのうち上位 8 ビット、256個分を表示しています。 1枠が 16MB になります。 また、X68030 ではこのうち 24ビット空間を別モニタで表示します。 こちらは 1枠 8KB x 2048個です。 どちらも内部構造を表示しているだけなので名前に馴染みがない場合があるかもしれません。 NEWS のデバイスマップは内部構造の都合上、 内部状態を正確に反映していないケースがあるかも知れません。
4.19. キー入力モード Key input mode
LUNA も X68030 もキーボードは通常日本語キーボードです (LUNA には英語キーボードも存在するようですが…)。 そのため、ホストが日本語キーボードの場合とそうでない場合のために 2つの入力モードを用意しています。 どちらも一長一短があります。 LUNA and X68030 has the Japanese keyboard (though I ever heard there are US keyboard for LUNA...). So nono provides two input modes for Japanese keyboard users and non Japanese keyboard users. Both have advantages and disadvantages.

JP キーボードモードは、ホストが日本語キーボードであることを前提に 対応するキーの押下、開放をその都度 VM に入力します。 メリットとしては動作が実機に近くなり、 特にキーリピート(をハードウェアが行わないこと)も忠実に再現可能です。 デメリットは ALT + TAB やアクセラレータキーでメニューを開く場合などに キー入力が残ることがあることです (キーを押した後でフォーカスが外れるとキーを離したことが アプリケーションに通知されないため)。 またホストが日本語キーボードでなければ使いづらいです。 JP keyboard mode assumes that the host uses the Japanese keyboard. Each time you presses and releases a key, nono sends the corresponding key-pressed or key-released to the VM. One advantage is that it's close to the real machine behavior, and another is that it can reproduce the LUNA keyboard itself does not perform a key repeat. On the other hand, one disadvantage is that key sometimes remains pressed, especially when you enter ALT + TAB to switch the application or enter accelerator key to open the menu (If the application loses the focus after the key is pressed, the application will not receive the subsequent key release). And another disadvantage is that it will be hard to use for non Japenese keyboard users.

一方、キャラクタ入力モードは、ホストから入力された「文字」を 再び LUNA/X68030 のキーコードに解釈し直して VM に入力するモードです。 例えばゲスト OS に "@" を入力したい場合、 US キーボードなら [SHIFT] + [2] を、 JP キーボードなら [@] キーを押しますが、 どちらも VM には [@] キーの押下、[@] キーの開放が連続して送られます。 US キーボードで [SHIFT] を押したことは通知されません。 逆に "=" を入力したい場合、 US キーボードなら [=] キーを、 JP キーボードなら [SHIFT] + [-] を押しますが、 どちらも VM には [SHIFT]押下 → [-]押下 → [-]開放 → [SHIFT]開放のシーケンスが送られます。 このようにホストキーボードのレイアウトによらず、 入力したい文字が入力できるようになり、 通常のタイピングで困ることはないと思います。 デメリットは、通常の文字入力以外のタイピングはほぼ出来ないことです。 [SHIFT] キーを押したままにすることや、 文字が入力できないキーの組み合わせは入力出来ません。 もう一つのデメリットはキーリピート(をハードウェアが行わないこと)が再現できず、 ホスト側のキーリピートが効いてしまうことです (本来キーリピートが動作しない ROM やブートローダでもキーリピートが効くことは 一般ユーザからはメリットに感じられるかも知れませんが)。 In contrast, in the character mode, when you type a character, nono re-converts it into the LUNA/X68030's key code and sends it to the VM. For example if you want to type "@" in the guest OS, you would press [SHIFT] + [2] on the US keyboard or [@] on the JP keyboard. In both cases, the sequence of [@]-pressed and [@]-released will be sent to the VM. Note that the fact that you pressed [SHIFT] key on the US keyboard will not be sent to the VM. Another example, if you want to type "=", you would press [=] on the US keyboard or [SHIFT] + [-] on the JP keyboard. In both cases, the sequence of [SHIFT]-pressed, [-]-pressed, [-]-released, and [SHIFT]-released will be sent to the VM. Thus, you can type what character you want to type, regardless of your keyboard layout. Of course there are some disadvantages. Firstly, it's hard to type any special characters, for example, you can not type any key conbinations that don't generate a character. Or you can not hold [SHIFT] key pressed. Secondly, the key repeat works (by the host), even though it should not work as a correct emulation (Although some of you may feel it an advantage).

4.20. キャラクタ入力モードのキーコード対応表 Keycode table in the character mode
キャラクタ入力モードでの、ホストから入力した文字と VM に送信されるキーの対応は次の通りです。 ファンクションキーとカーソルキーは文字ではありませんが 特別に対応しています。 ここに記載のないゲストキーはソフトウェアキーボードからのみ入力できます。 The following table shows the correspondence between the character that typed from the host and the key that will be sent to the VM. nono can recognize the function keys and arrow keys. The keys that not listed in this table can only be typed from the software keyboard window.

HostChar | GuestKey
--- | ---
`a` 〜 `z` | [A] 〜 [Z]
`0` 〜 `9` | [0] 〜 [9]
SPACE | [SPACE]
`-` | [-]
`^` | [^]
`\` | [\]
`@` | [@]
`[` | [[]
`;` | [;]
`:` | [:]
`]` | []]
`,` | [,]
`.` | [.]
`/` | [/]

HostChar | GuestKey
--- | ---
`A` 〜 `Z` | [SHIFT]+[A] 〜 [SHIFT]+[Z]
`!` | [SHIFT]+[1]
`"` | [SHIFT]+[2]
`#` | [SHIFT]+[3]
`$` | [SHIFT]+[4]
`%` | [SHIFT]+[5]
`&` | [SHIFT]+[6]
`'` | [SHIFT]+[7]
`(` | [SHIFT]+[8]
`)` | [SHIFT]+[9]
`=` | [SHIFT]+[-]
`~` | [SHIFT]+[^]
`|` | [SHIFT]+[\]
``` | [SHIFT]+[@]
`{` | [SHIFT]+[[]
`+` | [SHIFT]+[;]
`*` | [SHIFT]+[:]
`]` | [SHIFT]+[]]
`<` | [SHIFT]+[,]
`>` | [SHIFT]+[.]
`?` | [SHIFT]+[/]
`_` | [SHIFT]+[_]

HostChar | GuestKey
--- | ---
F1 〜 F10 | [PF1] 〜 [PF10]
F11 | [PF10]
↑ | [↑]
← | [←]
→ | [→]
↓ | [↓]
`^@` | [CTRL]+[@]
`^A` 〜 `^Z` | [CTRL]+[A] 〜 [CTRL]+[Z]
`^[` | [ESC]
`^\` | [CTRL]+[\]
`^]` | [CTRL]+[]]
`^^` | [CTRL]+[^]
`^_` | [CTRL]+[_]
`^H` | [BS]
`^I` | [TAB]
`^M` | [Enter]

4.21. JP キーボードモードのキーコード対応表 Keycode table in the JP keyboard mode
JP キーボードモードでの、ホストキーと VM に送信されるキーの対応は次の通りです。 ここに記載のないキーはソフトウェアキーボードからのみ入力出来ます。 The following table shows the correspondence between the host key and the guest key. The keys that not listed in this table can only be entered from the software keyboard window.

HostKey | GuestKey
--- | ---
[0] 〜 [9] | [0] 〜 [9]
[A] 〜 [Z] | [A] 〜 [Z]
[-] | [-]
[^] | [^]
[\] | [\]
[@] | [@]
[[] | [[]
[;] | [;]
[:] | [:]
[]] | []]
[,] | [,]
[.] | [.]

HostKey | GuestKey
--- | ---
[/] | [/]
[_] | [_]
[ESC] | [ESC]
[TAB] | [TAB]
[CTRL] | [CTRL]
[SHIFT-L] | [SHIFT-L]
[SHIFT-R] | [SHIFT-R]
[Enter] | [Enter]
[↑] | [↑]
[←] | [←]
[→] | [→]
[↓] | [↓]

HostKey | GuestKey
--- | ---
[BS] | [BS]
[Delete] | [DEL]
[F1] 〜 [F10] | [PF1] 〜 [PF10]
[F11] | [PF10]
Numpad[0]〜[9] | Numpad[0]〜[9]
Numpad[+] | Numpad[+]
Numpad[-] | Numpad[-]
Numpad[*] | Numpad[*]
Numpad[/] | Numpad[/]
Numpad[=] | Numpad[=]
Numpad[.] | Numpad[.]
Numpad[Enter] | Numpad[Enter]

(X68030 Only)
HostKey | GuestKey
--- | ---
[Home] | [HOME]
[Insert] | [INS]
[PageUp] | [ROLL UP]
[PageDown] | [ROLL DOWN]
[End] | [UNDO]

4.22. キーリピート Key Repeat
LUNA では、キーボードがハードウェア側でキーリピートを行わず、 ソフトウェア(OS など)がキーリピートの処理を行います。 そのため、キーリピートを実装していない LUNA の PROM や NetBSD/luna68k のブートローダではキーリピートは起きず、 キーリピートを実装している NetBSD/luna68k カーネルではキーリピートが起こせます。 キーリピートを起こす間隔をゲストのソフトウェアが測定しているということは、 VM が高速動作するとキーリピートもそれに合わせて発生することになり、 これをホスト側から防ぐ手段はありません。 そこで nono ではキー入力が発生している間 (キーが一つでも押されてからキーが全て離されるまでの間)、 高速モードが指示されていても VM を一時的に等速モードに落として実行します。 上記のアイコンがそれを区別しているのはこのためです。 そのため、何らかの理由でキーが入りっぱなしになった場合 (ALT + TAB やアクセラレータキーでメニューを開くと起きがちです) 高速モードが抑制されたままということが起きえます。 その場合はソフトウェアキーボードからキー入力を解除するなどしてください。 On LUNA, key repeat is done by software(OS), not by the keyboard hardware. For this reason, key repeat doesn't occur on LUNA's PROM or NetBSD/luna68k's bootloader that don't implement it, and key repeat occurs on NetBSD/luna68k kernel that implements it. Since the timing of key repeat is measured by the guest software, if the VM is running faster than the real, the key repeat will occur faster, too. The host application doesn't have the way to avoid it. Therefore, nono will temporarily suppress the full speed mode while any keys are pressed on LUNA. That is why the above-mentioned icon distinguishes them. If keys continue to be pressed for some reasons, the VM also continues to run syncronized mode. In this case, you can resolve it by using the software keyboard window.
5. 実行してみる Try it
5.1. NetBSD/luna68k を実行してみる Try NetBSD/luna68k
つついさんが NetBSD/luna68k 9.2 の liveimage を用意されています。 Tsutsui-san has provided a liveimage of NetBSD/luna68k 9.2.

  https://twitter.com/tsutsuii/status/1436381589211017217

ここではこれを起動してみます。Let's try it.

1. どこかに nono 用のディレクトリを用意し(例えば ~/nono/)、 その中に VM ディレクトリを用意します (例えば ~/nono/luna/)。 Create a directory somewhere for nono (for example ~/nono/), and create subdirectories for individual VMs in it (for example ~/nono/luna/).
2. 以下のリンクからイメージファイルをダウンロードして展開し、 VM ディレクトリ ~/nono/luna/ に置きます。 Download imagefile from the following link, extract it and place it in the VM directory, ~/nono/luna/.

   > http://teokurebsd.org/netbsd/liveimage/20210910-luna68k/

3. 以下の内容の設定ファイル nono.cfg を VM ディレクトリ ~/nono/luna/ に作成します。 Create a configuration file nono.cfg in the VM directory, ~/nono/luna/, with following contents.

   >     vmtype = luna
   >     spc0-id6-image = hd,liveimage-luna68k-with-packages-20210910.img

4. `nono -c ~/nono/luna` で起動します (VM ディレクトリに自動的に NVRAM.DAT が作られます)。 Run as `nono -c ~/nono/luna`. (NVRAM.DAT will be created automatically in the VM directory)
5. Emulated ROM Monitor が起動するので、 初回は以下のように入力すると NetBSD が起動します。 The emulated ROM Monitor will be executed. Then, only for the first time, entering the following can boot NetBSD.

   >     k⏎
   >     ⏎
   >     ⏎
   >     d⏎
   >     boot⏎
   >     g⏎
   >     x⏎

   画面はこんな感じのはずです (太字が入力部分)。 You will see a screen like this. The bold text indicates the characters you need to enter.

   >     NONO 1.6.4 Emulated ROM Monitor for LUNA-I

   >     ** NVRAM Initialized.

   >     >k⏎
   >     controller: dk  ?⏎
   >     drive unit: 0  ?⏎
   >     partition : c  ?d⏎
   >     filename  : vmunix  ?boot⏎
   >     >g⏎
   >     Loaded.  Entry point = $00700000
   >     >x⏎

   この内容は NVRAM.DAT に記録されているので次回以降は直接 NetBSD が起動します。 The information you have just entered is recorded in the NVRAM, so next time it will boot NetBSD automatically.
6. 初回起動時、 Updating fontconfig cache はあほみたいに時間がかかりますが、 nono がハングアップしてるわけではありません(>_<)。 また初回は起動後数時間めちゃくちゃ重たいですが、 これはバックグラウンドで makemandb が動くためで nono のせいではありません(>_<)。 At the first boot, you will see the console stops after printing "Updating fontconfig cache". This is because the infamous fontconfig takes very looooong time. nono would not have hang-up. In addition, at the first boot, you will feel it's too heavy for several hours. This is because the infamous makemandb(8) runs heavily in the background for a looooong time. It's very sad to me that these two accidents which are far from the ideal are the first experiences of newcomers.
7. 終了する時は root ユーザで “`shutdown -p now`” を実行してください。 LUNA はソフトウェアから電源オフでき、 VM の電源オフで nono も終了します。 To quit, type “`shutdown -p now`” as the root user. LUNA can be powered off by software, and nono will terminate when the VM is powered off.

5.2. OpenBSD/luna88k を実行してみる Try OpenBSD/luna88k
あおやまさんが OpenBSD/luna88k 7.7 の liveimage を用意されています。 Aoyama-san has provided a liveimage of OpenBSD/luna88k 7.6.

  https://bsd.network/@ao_kenji/114436150104520496

ここではこれを起動してみます。Let's try it.

1. どこかに nono 用のディレクトリを用意し(例えば ~/nono/)、 その中に VM ディレクトリを用意します (例えば ~/nono/luna88k/)。 Create a directory somewhere for nono (for example ~/nono/), and create subdirectories for individual VMs in it (for example ~/nono/luna88k/).
2. 以下のリンクから liveimage-luna88k-raw-20250518.img.gz をダウンロードして展開し、 VM ディレクトリ ~/nono/luna88k/ に置きます。 Download liveimage-luna88k-raw-20250518.img.gz from the following link, extract it and place it in the VM directory, ~/nono/luna88k/.

   > http://www.nk-home.net/~aoyama/liveimage/

3. 以下の内容の設定ファイル nono.cfg を VM ディレクトリ ~/nono/luna88k/ に作成します。 Create a configuration file nono.cfg in the VM directory, ~/nono/luna88k/, with following contents.

   >     vmtype = luna88k
   >     spc0-id6-image = hd,liveimage-luna88k-raw-20241013.img

4. `nono -c ~/nono/luna88k` で起動します (VM ディレクトリに自動的に NVRAM.DAT が作られます)。 Run as `nono -c ~/nono/luna88k`. (NVRAM.DAT will be created automatically in the VM directory)
5. Emulated ROM Monitor が起動するので、 初回は以下のように入力すると OpenBSD が起動します。 The emulated ROM Monitor will be executed. Then, only for the first time, entering the following can boot OpenBSD.

   >     nvram boot_filename boot⏎
   >     y
   >     b⏎

   画面はこんな感じのはずです (太字が入力部分)。 You will see a screen like this. The bold text indicates the characters you need to enter.

   >     NONO 1.6.4 Emulated ROM Monitor for LUNA-88K

   >     ** NVRAM Initialized.

   >     N>nvram boot_filename boot⏎
   >     Update boot_filename : "vmunix" -> "boot" (Y/[N]):y
   >     Updated
   >     N>b⏎

   この内容は NVRAM.DAT に記録されているので次回以降は直接 OpenBSD が起動します。 The information you have just entered is recorded in the NVRAM, so next time it will boot OpenBSD automatically.
6. 終了する時は root ユーザで “`shutdown -p now`” を実行してください。 LUNA-88K はソフトウェアから電源オフでき、 VM の電源オフで nono も終了します。 To quit, type “`shutdown -p now`” as the root user. LUNA-88K can be powered off by software, and nono will terminate when the VM is powered off.

5.3. NetBSD/x68k を実行してみる Try NetBSD/x68k
つついさんが NetBSD/x68k 10.1 の liveimage を用意されています。 ここではこれを起動してみます。 Tsutsui-san has provided a liveimage of NetBSD/x68k 10.1. Let's try it.

1. どこかに nono 用のディレクトリを用意し(例えば ~/nono/)、 その中に VM ディレクトリを用意します (例えば ~/nono/x68k/)。 Create a directory somewhere for nono (for example ~/nono/), and create subdirectories for individual VMs in it (for example ~/nono/x68k/).
2. 以下のサイトから 「パッケージインストール設定済み版」か 「インストーラでインストールしたところまでの未設定版」の お好みのほうをダウンロードします。 迷ったら「パッケージインストール設定済み版」がよいでしょう。 ダウンロードできたら展開して、VM ディレクトリ ~/nono/x68k/ に置きます。 Download your favorite one of with-packages or plain-install from the following site. Extract it and place it in the VM directory, ~/nono/x68k/.

   > http://www.ceres.dti.ne.jp/tsutsui/netbsd/liveimage/x68k.html

3. 以下の内容の設定ファイル nono.cfg を VM ディレクトリ ~/nono/x68k/ に作成します。 Create a configuration file nono.cfg in the VM directory, ~/nono/x68k/, with following contents.

   >     vmtype = x68030
   >     spc0-id0-image = hd,liveimage-x68k-with-packages-20250106.hds

4. `nono -c ~/nono/x68k` で起動します (VM ディレクトリに自動的に SRAM.DAT が作られます)。 Run as `nono -c ~/nono/x68k` (SRAM.DAT will be created automatically in the VM directory).
5. 初回の NetBSD/x68k 起動後数時間はめちゃくちゃ重たいですが、 これはバックグラウンドで makemandb が動くためで nono のせいではありません(>_<)。 At the first NetBSD/x68k boot, you will feel it's too heavy for several hours. This is because the infamous makemandb(8) runs heavily in the background for a looooong time. It's very sad to me that the accident which is far from the ideal is the first experiences of newcomers.
6. NetBSD が起動した後なら (正確には powerd(8) が起動していれば)、 終了する時はメニューの「デバイス > 操作 > 電源ボタンを押す」 でシャットダウンして電源オフになり、 VM の電源オフで nono も終了します。 After NetBSD boots up (more precisely, if powerd(8) is running), you can shutdown and power off by "Device > Operation > Push Power button" on menu, and nono will terminate when the VM is powered off.

5.4. NetBSD/virt68k をインストールしてみる Try installing NetBSD/virt68k
ここでは NetBSD/virt68k をインストールする手順を紹介します。 Here I will introduce how to install NetBSD/virt68k.

1. どこかに nono 用のディレクトリを用意し(例えば ~/nono/)、 その中に VM ディレクトリを用意します (例えば ~/nono/virt68k/)。 Create a directory somewhere for nono (for example ~/nono/), and create subdirectories for individual VMs in it (for example ~/nono/virt68k/).
2. NetBSD/virt68k を含む 11.0 は執筆時点ではまだリリースされていませんが、 公式サイトにリリースブランチのデイリービルドがあります。 以下のリンクから netbsd-GENERIC.gz (カーネル) と inst-ramdisk.fs (インストーライメージ) をダウンロードします。

   > https://nycdn.netbsd.org/pub/NetBSD-daily/netbsd-11/latest/virt68k/binary/kernel/netbsd-GENERIC.gz
   > https://nycdn.netbsd.org/pub/NetBSD-daily/netbsd-11/latest/virt68k/installation/ramdisks/inst-ramdisk.fs

3. 空のディスクイメージを用意します。 1GB でもインストール自体は出来ますが、もう少し大きいほうが安心です。 Prepare an empty disk image file. You can install it with 1GB at least, but it would be safer if it was a little larger.

   >     dd if=/dev/zero of=virt68k.img bs=1m count=2048

4. 以下の内容の設定ファイル nono.cfg を VM ディレクトリ ~/nono/virt68k に作成します。 Create a configuration file nono.cfg in the VM directory, ~/nono/virt68k/, with following contents.

   >     vmtype = virt-m68k
   >     exec-file = netbsd-GENERIC.gz
   >     exec-bootparam = root=ld0
   >     virtio-block0-image = virt68k.img
   >     fast-mode = 1

5. インストーラ RAM ディスクを指定してインストーラを起動します。 設定ファイルでルートデバイスを ld0 に指定していますが、 RAM ディスク指定のほうが優先されるようです。 Run the installer by specifying installer RAM disk. By the way, configuration file specifies root device as ld0, but RAM disk specified by the command line will take precedence.

   >     nono -c ~/nono/virt68k --initrd inst-ramdisk.fs

6. しばらくすると見慣れたインストーラが起動してきます。 インストールが終わったらトップメニューから e:Utility menu > g:Halt the system を選択してください。ゲストの電源がオフになり nono も終了します。 After a while, the familiar installer will start. Once the installation has finished, select e:Utility menu > g:Halt the system. Then the guest will shut down, and nono also will terminate.
7. インストールしたディスクから起動するには、 `--initrd` オプションを外して実行します。 カーネルは引き続きホストファイルシステム上にあるもの (ここでは ~/nono/virt68k/netbsd-GENERIC.gz) を使います。 To boot from the installed disk, run without `--initrd` option. It still uses the kernel on the host filesystem, just like the installer does.

   >     nono -c ~/nono/virt68k

6. ホストネットワーク設定例 Example of host network setup
6.1. tap
NetBSD の tap(4) デバイスを用いて、 ホストの wm0 と nono のゲスト OS を接続する場合の設定例です。

1. 設定ファイル nono.cfg に以下の行を追加します。 Add the following line to configuration file, nono.cfg.

   >     hostnet-driver = tap
   >     hostnet-tap-devpath = auto

2. デフォルトでは /dev/tap は一般ユーザからアクセスできないので、 chmod で適当にパーミッションを与えます。 番号の付いていないほうの /dev/tap だけでいいです。 sysinst 等で OS をアップグレードするとパーミッションが 600 に戻るのがハマりポイントです。 By default, /dev/tap is only accessible to privileged user. You need to chmod /dev/tap (without unit number) appropriately. Note that upgrading using sysinst always resets the permission to 600.
3. bridge(4) インタフェースを作成し、 ホストの外部(物理)インタフェースをブリッジに追加しておきます。 Create a bridge(4) interface, and add your physical interface to the bridge.

   >     # ifconfig bridge0 create
   >     # brconfig bridge0 add wm0

   常用するなら /etc の設定ファイルに書いておきましょう。 If you use it regularly, you can put configuration file into /etc.

   > /etc/ifconfig.bridge0

   >     create
   >     up
   >     !/sbin/brconfig $int add wm0

   >     # /etc/rc.d/network restart

4. 一般ユーザに戻って、 VM ディレクトリかその親ディレクトリに 次のような 2つのスクリプトを用意します。 nono は tap(4) をオープンし、 そのデバイス名を引数にこれらのスクリプトを呼びます。 sudo の設定は別途行ってください。 Return to non-privileged user, and create following two scripts in the VM directory or its parent directory. nono will open tap(4) and invoke these scripts with the name of the device as an argument. In addition, you need to set up sudo separately.

   > nono-ifup

   >     #!/bin/sh
   >     sudo /sbin/ifconfig $1 up
   >     sudo /sbin/brconfig bridge0 add $1

   > nono-ifdown

   >     #!/bin/sh
   >     sudo /sbin/brconfig bridge0 delete $1
   >     sudo /sbin/ifconfig $1 down

   >     % chmod +x nono-ifup nono-ifdown

5. nono を起動し、 メニューの「モニタ > ホスト > ホストネットワーク」を開いて HostNet Driver: tap になっていれば動いてるはずです。 Run nono, and open "Monitor > Host > Host Network" window from menu. It's OK if you can see "HostNet Driver: tap".

7. 既知の問題 Known Issues

- デバッガのコンソール入力で、 カーソルキーなどの特殊文字入力に対する表示が動作していません。 In debugger console, some special characters like cursor keys aren't printed correctly. (since ver 0.3.0)
- ホストが VirtualBox (on Windows?) で、 VirtualBox の「マウス統合」が有効にしている場合、 nono の「マウスモード」でマウスポインタが正しく移動しません。 If the host OS is running on VirtualBox (on Windows?) and "Mouse integration" on VirtualBox is enabled, the mouse pointer will not move as expected in nono's Mouse Mode. (2021/12/30)
- Wayland の場合にウィンドウサイズが正しく設定されない場合があります。 wxWidgets (3.0/3.2) のバグと思われます。 On Wayland, window size may be incorrect. This may be due to wxWidgets (3.0/3.2) bug. (2021/12/30, Updated 2024/07/03)
- nono ではありませんが、wxWidgets 3.2 (with GTK3) は NetBSD/sparc (などマイナーアーキテクチャ?) でウィンドウ内がほぼ描画されないようです。 wxWidgets 3.0 (with GTK2) であれば動作します。 On wxWidgets 3.2 (with GTK3), it seems that the inside of the window is hardly drawn at NetBSD/sparc (and such minor architectures?). wxWidgets 3.0 (with GTK2) can. (2024/07/03)

8. 過去のバージョンからの移行方法 How to migrate from old versions
バージョンアップに伴い設定ファイル等に非互換が発生する場合があります。 その場合は以下の移行方法を参照して設定ファイル等を更新してください。 Some versions may have incompatibilities in the configuration files, etc. In such case, you may need to upgrade it by referring the following link.

- From ver 1.5.0 to ver 1.6.0
- From ver 1.1.x to ver 1.2.0

9. 付属ソフトウェア Included Software

- runx

10. 変更履歴 Changes
See changes.html .
11. 連絡先、ライセンス等 Contact, License, etc
11.1. ライセンス License

- nono 自身については nono-license.txt を読んでください。 See nono-license.txt about nono itself.
- nono は無償公開されている X68030 の IPLROM を使用しています。 許諾条件を読んでください。 nono uses X68030 IPLROM image distributed without charge. You must read the license agreement (even though it's Japanese original text only).
- nono は SIL Open Font License version 1.1 で配布されているフォントの 一部を改変して組み込んでいます。 nono modifies and embeds the font distributed as SIL Open Font License version 1.1.

11.2. 連絡先 Contact us
バグ報告などは以下にお願いします。日本語でおk。 If you find any problems, please let me know. You may write in English.
https://github.com/isaki68k/nono-issue/issues
11.3. パッチの提供について About contributes
パッチを提供してくださる場合は以下に同意したものとします。 If you provide a patch to nono, we assume that you agree the following conditions:

- 成果物が nono のライセンスに従って運用あるいは配布されること。 All your work will be operated or distributed under the nono license.
- ライセンスが将来変わる可能性があること。 The license may be changed in the future.
- 著作部分に関して著作者人格権を行使しないこと。 Do not exercise your author's rights.

11.4. Acknowledgements
nono は以下の広告条項を含むソースコードを利用しています。 nono uses source code with the following advertising clause.

> This product includes software developed by Gordon Ross
> This product includes software developed by the University of California, Lawrence Berkeley Laboratory.

nono project